#include "Parse.h"
#include <string>
#include <cctype>
#include <iostream>
#include <cstdlib>
#include <sstream>
#include <stack>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

//Read the input file and add '$' to the end
bool CParse::ReadFile(string fileName)
{
    ifstream infile;
	infile.open(fileName.c_str(), std::ios::in|std::ios::binary|std::ios::ate);
	//readPos=0;
	if (infile.is_open())
	{
		memSize = infile.tellg();
		memblock = new char [memSize+1];
		infile.seekg (0, std::ios::beg);  //Move read point to the head of the file
		infile.read (memblock, memSize);  //Read the whole program into the memory block
		infile.close();					  //Close file
		memblock[memSize]='$';			  //Add the ending symbol 
		return true;
	}
	else return false;
	
}

//Construct the symbol table for parsing
CParse::CParse(Program* p, Query *q):prg(p),qry(q), memSize(0), readPos(0),symbolId(0)
{
	std::string slist="";
	std::string name="";
	int sLen;
	int i,j;
	int k=0;

	//S_ S SE . DEFR APGR RSRL PRRL QRRL TERM = { TL } const .. IDL : -> id # domain ( VL ) , var ; 
	//SYM EXP + TTD - * FCT / ATOM LIT obs do :- BODY [ ] +- BLT not CMP == <> >= <= < > RHD 
	//random pr | QHD ? FLL FML and or ! $ 
	//66

	slist=slist+"S_ S SE . DEFR APGR RSRL PRRL QRRL TERM = { TL } const .. IDL : -> id # domain ( VL ) , var ; ";//20 id=11 const=12 var=13
	slist=slist+"SYM EXP + TTD - * FCT / ATOM LIT obs do :- BODY [ ] +- BLT not CMP == <> >= <= < > RHD ";//var 39    
	slist=slist+"random pr | QHD ? FLL FML and or ! $ ";
	//slist=slist+"RHD [ ] random pr | QHD prob FML most and or ! # domain VL ; $ ";
	//********************************************************************************************************************************
	//Jan 29
	// Construct the initial symbolTable
	//Can be redone by using string stream getWord method?
	sLen=slist.size();
	//DEBUG
	//std::cout<<slist<<std::endl;
	for(i=0;i<sLen;i++){
		if(slist[i]!=' '){
			name.insert(name.size(),1,slist[i]);
		}
		else {
			if(!isupper(name[0])) symbolTable[name]=k;
			++k;
			name="";
		}
	}
	//DEBUG
	//std::cout<<slist<<std::endl;
	//Initialize the two parse table
	for(i=0;i<dfptbl;i++){
		for(j=0;j<dfsym;j++){
			shift[i][j]=-1;
			reduce[i][j]=-1;
		}
	}
	//------------------------------
	//Grammar Table
igr[0][0]=0;igr[0][1]=1;
shift[0][1]=1;
shift[0][2]=2;
shift[0][4]=3;
shift[0][5]=4;
shift[0][6]=5;
shift[0][7]=6;
shift[0][8]=7;
shift[0][9]=8;
shift[0][14]=9;
shift[0][16]=10;
shift[0][19]=11;
shift[0][20]=12;
shift[0][22]=13;
shift[0][26]=14;
shift[0][28]=15;
shift[0][29]=16;
shift[0][31]=17;
shift[0][32]=18;
shift[0][34]=19;
shift[0][36]=20;
shift[0][37]=21;
shift[0][38]=22;
shift[0][39]=23;
shift[0][40]=24;
shift[0][42]=25;
shift[0][54]=26;
shift[0][58]=27;
shift[0][59]=28;
shift[2][3]=29;
shift[8][10]=30;
shift[10][17]=31;
shift[10][25]=32;
shift[11][22]=33;
shift[12][21]=34;
shift[13][14]=35;
shift[13][19]=36;
shift[13][22]=37;
shift[13][26]=38;
shift[13][28]=39;
shift[13][29]=40;
shift[13][31]=41;
shift[13][34]=42;
shift[16][30]=43;
shift[16][32]=44;
shift[17][33]=45;
shift[17][35]=46;
shift[18][9]=47;
shift[18][14]=9;
shift[18][19]=48;
shift[18][22]=13;
shift[18][26]=14;
shift[18][28]=15;
shift[18][29]=16;
shift[18][31]=17;
shift[18][34]=19;
shift[18][36]=49;
shift[21][40]=50;
shift[22][22]=51;
shift[23][22]=52;
shift[24][9]=53;
shift[24][14]=54;
shift[24][19]=55;
shift[24][22]=56;
shift[24][26]=57;
shift[24][28]=58;
shift[24][29]=59;
shift[24][31]=60;
shift[24][32]=61;
shift[24][34]=62;
shift[24][36]=63;
shift[24][37]=64;
shift[24][38]=65;
shift[24][39]=66;
shift[24][41]=67;
shift[24][45]=68;
shift[24][46]=69;
shift[24][47]=70;
shift[25][9]=71;
shift[25][14]=72;
shift[25][19]=73;
shift[25][22]=74;
shift[25][26]=75;
shift[25][28]=76;
shift[25][29]=77;
shift[25][31]=78;
shift[25][34]=79;
shift[26][40]=80;
shift[27][57]=81;
shift[28][11]=82;
shift[28][42]=83;
shift[28][52]=84;
shift[29][1]=85;
shift[29][2]=2;
shift[29][4]=3;
shift[29][5]=4;
shift[29][6]=5;
shift[29][7]=6;
shift[29][8]=7;
shift[29][9]=8;
shift[29][14]=9;
shift[29][16]=10;
shift[29][19]=11;
shift[29][20]=12;
shift[29][22]=13;
shift[29][26]=14;
shift[29][28]=15;
shift[29][29]=16;
shift[29][31]=17;
shift[29][32]=18;
shift[29][34]=19;
shift[29][36]=20;
shift[29][37]=21;
shift[29][38]=22;
shift[29][39]=23;
shift[29][40]=24;
shift[29][42]=25;
shift[29][54]=26;
shift[29][58]=27;
shift[29][59]=28;
shift[30][9]=86;
shift[30][11]=87;
shift[30][14]=88;
shift[30][19]=89;
shift[30][22]=90;
shift[30][26]=91;
shift[30][28]=92;
shift[30][29]=93;
shift[30][31]=94;
shift[30][34]=95;
shift[31][16]=96;
shift[31][19]=97;
shift[32][19]=98;
shift[33][9]=99;
shift[33][12]=100;
shift[33][14]=101;
shift[33][19]=102;
shift[33][22]=103;
shift[33][26]=104;
shift[33][28]=105;
shift[33][29]=106;
shift[33][31]=107;
shift[33][34]=108;
shift[34][19]=109;
shift[37][14]=35;
shift[37][19]=36;
shift[37][22]=37;
shift[37][26]=38;
shift[37][28]=39;
shift[37][29]=110;
shift[37][31]=41;
shift[37][34]=42;
shift[40][24]=111;
shift[40][30]=112;
shift[40][32]=113;
shift[41][33]=114;
shift[41][35]=115;
shift[43][14]=9;
shift[43][19]=116;
shift[43][22]=13;
shift[43][26]=14;
shift[43][28]=15;
shift[43][31]=117;
shift[43][34]=19;
shift[44][14]=9;
shift[44][19]=116;
shift[44][22]=13;
shift[44][26]=14;
shift[44][28]=15;
shift[44][31]=118;
shift[44][34]=19;
shift[45][14]=9;
shift[45][19]=116;
shift[45][22]=13;
shift[45][26]=14;
shift[45][28]=15;
shift[45][34]=119;
shift[46][14]=9;
shift[46][19]=116;
shift[46][22]=13;
shift[46][26]=14;
shift[46][28]=15;
shift[46][34]=120;
shift[47][10]=121;
shift[48][22]=33;
shift[50][9]=53;
shift[50][14]=54;
shift[50][19]=55;
shift[50][22]=56;
shift[50][26]=57;
shift[50][28]=58;
shift[50][29]=59;
shift[50][31]=60;
shift[50][32]=61;
shift[50][34]=62;
shift[50][36]=63;
shift[50][37]=64;
shift[50][38]=65;
shift[50][39]=66;
shift[50][41]=122;
shift[50][45]=68;
shift[50][46]=69;
shift[50][47]=70;
shift[51][9]=123;
shift[51][14]=124;
shift[51][19]=125;
shift[51][22]=126;
shift[51][26]=127;
shift[51][28]=128;
shift[51][29]=129;
shift[51][31]=130;
shift[51][32]=131;
shift[51][34]=132;
shift[51][36]=133;
shift[51][37]=134;
shift[51][38]=135;
shift[51][39]=136;
shift[52][9]=123;
shift[52][14]=124;
shift[52][19]=125;
shift[52][22]=126;
shift[52][26]=127;
shift[52][28]=128;
shift[52][29]=129;
shift[52][31]=130;
shift[52][34]=132;
shift[52][36]=137;
shift[53][10]=138;
shift[55][22]=139;
shift[56][14]=35;
shift[56][19]=36;
shift[56][22]=37;
shift[56][26]=38;
shift[56][28]=39;
shift[56][29]=140;
shift[56][31]=41;
shift[56][34]=42;
shift[59][30]=141;
shift[59][32]=142;
shift[59][48]=143;
shift[59][49]=144;
shift[59][50]=145;
shift[59][51]=146;
shift[59][52]=147;
shift[59][53]=148;
shift[60][33]=149;
shift[60][35]=150;
shift[61][9]=53;
shift[61][14]=151;
shift[61][19]=152;
shift[61][22]=153;
shift[61][26]=154;
shift[61][28]=155;
shift[61][29]=156;
shift[61][31]=157;
shift[61][34]=158;
shift[61][36]=159;
shift[65][22]=160;
shift[66][22]=161;
shift[67][25]=162;
shift[69][9]=53;
shift[69][14]=151;
shift[69][19]=152;
shift[69][22]=153;
shift[69][26]=154;
shift[69][28]=155;
shift[69][29]=156;
shift[69][31]=157;
shift[69][32]=61;
shift[69][34]=158;
shift[69][36]=63;
shift[69][37]=163;
shift[69][38]=65;
shift[69][39]=66;
shift[71][43]=164;
shift[73][22]=165;
shift[74][14]=35;
shift[74][19]=36;
shift[74][22]=37;
shift[74][26]=38;
shift[74][28]=39;
shift[74][29]=166;
shift[74][31]=41;
shift[74][34]=42;
shift[77][30]=167;
shift[77][32]=168;
shift[78][33]=169;
shift[78][35]=170;
shift[80][9]=53;
shift[80][14]=54;
shift[80][19]=55;
shift[80][22]=56;
shift[80][26]=57;
shift[80][28]=58;
shift[80][29]=59;
shift[80][31]=60;
shift[80][32]=61;
shift[80][34]=62;
shift[80][36]=63;
shift[80][37]=64;
shift[80][38]=65;
shift[80][39]=66;
shift[80][41]=171;
shift[80][45]=68;
shift[80][46]=69;
shift[80][47]=70;
shift[81][9]=53;
shift[81][14]=54;
shift[81][19]=55;
shift[81][22]=56;
shift[81][26]=57;
shift[81][28]=58;
shift[81][29]=59;
shift[81][31]=60;
shift[81][32]=61;
shift[81][34]=62;
shift[81][36]=63;
shift[81][37]=64;
shift[81][38]=65;
shift[81][39]=66;
shift[81][41]=172;
shift[81][45]=68;
shift[81][46]=69;
shift[81][47]=70;
shift[82][9]=173;
shift[82][14]=174;
shift[82][19]=175;
shift[82][22]=176;
shift[82][26]=177;
shift[82][28]=178;
shift[82][29]=179;
shift[82][31]=180;
shift[82][34]=181;
shift[82][36]=182;
shift[82][60]=183;
shift[82][61]=184;
shift[82][64]=185;
shift[83][9]=186;
shift[83][14]=187;
shift[83][19]=188;
shift[83][22]=189;
shift[83][26]=190;
shift[83][28]=191;
shift[83][29]=192;
shift[83][31]=193;
shift[83][34]=194;
shift[83][36]=195;
shift[83][60]=196;
shift[83][61]=197;
shift[83][64]=198;
shift[84][9]=199;
shift[84][12]=200;
shift[84][14]=201;
shift[84][19]=202;
shift[84][22]=203;
shift[84][26]=204;
shift[84][28]=205;
shift[84][29]=206;
shift[84][31]=207;
shift[84][34]=208;
shift[87][9]=209;
shift[87][12]=210;
shift[87][14]=211;
shift[87][19]=212;
shift[87][22]=213;
shift[87][26]=214;
shift[87][28]=215;
shift[87][29]=216;
shift[87][31]=217;
shift[87][34]=218;
shift[89][22]=219;
shift[90][14]=35;
shift[90][19]=36;
shift[90][22]=37;
shift[90][26]=38;
shift[90][28]=39;
shift[90][29]=220;
shift[90][31]=41;
shift[90][34]=42;
shift[93][30]=221;
shift[93][32]=222;
shift[94][33]=223;
shift[94][35]=224;
shift[96][18]=225;
shift[96][25]=226;
shift[100][24]=227;
shift[100][25]=228;
shift[102][22]=229;
shift[103][14]=35;
shift[103][19]=36;
shift[103][22]=37;
shift[103][26]=38;
shift[103][28]=39;
shift[103][29]=230;
shift[103][31]=41;
shift[103][34]=42;
shift[106][30]=231;
shift[106][32]=232;
shift[107][33]=233;
shift[107][35]=234;
shift[109][22]=235;
shift[110][24]=236;
shift[110][30]=112;
shift[110][32]=113;
shift[112][14]=35;
shift[112][19]=36;
shift[112][22]=37;
shift[112][26]=38;
shift[112][28]=39;
shift[112][31]=237;
shift[112][34]=42;
shift[113][14]=35;
shift[113][19]=36;
shift[113][22]=37;
shift[113][26]=38;
shift[113][28]=39;
shift[113][31]=238;
shift[113][34]=42;
shift[114][14]=35;
shift[114][19]=36;
shift[114][22]=37;
shift[114][26]=38;
shift[114][28]=39;
shift[114][34]=239;
shift[115][14]=35;
shift[115][19]=36;
shift[115][22]=37;
shift[115][26]=38;
shift[115][28]=39;
shift[115][34]=240;
shift[117][33]=45;
shift[117][35]=46;
shift[118][33]=45;
shift[118][35]=46;
shift[121][9]=86;
shift[121][14]=88;
shift[121][19]=89;
shift[121][22]=90;
shift[121][26]=91;
shift[121][28]=92;
shift[121][29]=93;
shift[121][31]=94;
shift[121][34]=95;
shift[122][25]=162;
shift[123][10]=241;
shift[125][22]=242;
shift[126][14]=35;
shift[126][19]=36;
shift[126][22]=37;
shift[126][26]=38;
shift[126][28]=39;
shift[126][29]=243;
shift[126][31]=41;
shift[126][34]=42;
shift[129][30]=244;
shift[129][32]=245;
shift[130][33]=246;
shift[130][35]=247;
shift[131][9]=123;
shift[131][14]=124;
shift[131][19]=125;
shift[131][22]=126;
shift[131][26]=127;
shift[131][28]=128;
shift[131][29]=129;
shift[131][31]=130;
shift[131][34]=132;
shift[131][36]=248;
shift[134][24]=249;
shift[135][22]=250;
shift[136][22]=251;
shift[137][24]=252;
shift[138][9]=253;
shift[138][14]=254;
shift[138][19]=255;
shift[138][22]=256;
shift[138][26]=257;
shift[138][28]=258;
shift[138][29]=259;
shift[138][31]=260;
shift[138][34]=261;
shift[139][9]=99;
shift[139][12]=262;
shift[139][14]=101;
shift[139][19]=102;
shift[139][22]=103;
shift[139][26]=104;
shift[139][28]=105;
shift[139][29]=106;
shift[139][31]=107;
shift[139][34]=108;
shift[140][24]=263;
shift[140][30]=112;
shift[140][32]=113;
shift[141][14]=54;
shift[141][19]=264;
shift[141][22]=56;
shift[141][26]=57;
shift[141][28]=58;
shift[141][31]=265;
shift[141][34]=62;
shift[142][14]=54;
shift[142][19]=264;
shift[142][22]=56;
shift[142][26]=57;
shift[142][28]=58;
shift[142][31]=266;
shift[142][34]=62;
shift[143][14]=254;
shift[143][19]=267;
shift[143][22]=256;
shift[143][26]=257;
shift[143][28]=258;
shift[143][29]=268;
shift[143][31]=260;
shift[143][34]=261;
shift[144][14]=254;
shift[144][19]=267;
shift[144][22]=256;
shift[144][26]=257;
shift[144][28]=258;
shift[144][29]=269;
shift[144][31]=260;
shift[144][34]=261;
shift[145][14]=254;
shift[145][19]=267;
shift[145][22]=256;
shift[145][26]=257;
shift[145][28]=258;
shift[145][29]=270;
shift[145][31]=260;
shift[145][34]=261;
shift[146][14]=254;
shift[146][19]=267;
shift[146][22]=256;
shift[146][26]=257;
shift[146][28]=258;
shift[146][29]=271;
shift[146][31]=260;
shift[146][34]=261;
shift[147][14]=254;
shift[147][19]=267;
shift[147][22]=256;
shift[147][26]=257;
shift[147][28]=258;
shift[147][29]=272;
shift[147][31]=260;
shift[147][34]=261;
shift[148][14]=254;
shift[148][19]=267;
shift[148][22]=256;
shift[148][26]=257;
shift[148][28]=258;
shift[148][29]=273;
shift[148][31]=260;
shift[148][34]=261;
shift[149][14]=54;
shift[149][19]=264;
shift[149][22]=56;
shift[149][26]=57;
shift[149][28]=58;
shift[149][34]=274;
shift[150][14]=54;
shift[150][19]=264;
shift[150][22]=56;
shift[150][26]=57;
shift[150][28]=58;
shift[150][34]=275;
shift[152][22]=139;
shift[153][14]=35;
shift[153][19]=36;
shift[153][22]=37;
shift[153][26]=38;
shift[153][28]=39;
shift[153][29]=276;
shift[153][31]=41;
shift[153][34]=42;
shift[156][30]=277;
shift[156][32]=278;
shift[157][33]=279;
shift[157][35]=280;
shift[160][9]=123;
shift[160][14]=124;
shift[160][19]=125;
shift[160][22]=126;
shift[160][26]=127;
shift[160][28]=128;
shift[160][29]=129;
shift[160][31]=130;
shift[160][32]=131;
shift[160][34]=132;
shift[160][36]=133;
shift[160][37]=281;
shift[160][38]=135;
shift[160][39]=136;
shift[161][9]=123;
shift[161][14]=124;
shift[161][19]=125;
shift[161][22]=126;
shift[161][26]=127;
shift[161][28]=128;
shift[161][29]=129;
shift[161][31]=130;
shift[161][34]=132;
shift[161][36]=282;
shift[162][9]=53;
shift[162][14]=54;
shift[162][19]=55;
shift[162][22]=56;
shift[162][26]=57;
shift[162][28]=58;
shift[162][29]=59;
shift[162][31]=60;
shift[162][32]=61;
shift[162][34]=62;
shift[162][36]=63;
shift[162][37]=64;
shift[162][38]=65;
shift[162][39]=66;
shift[162][45]=283;
shift[162][46]=69;
shift[162][47]=70;
shift[164][9]=284;
shift[164][14]=285;
shift[164][19]=286;
shift[164][22]=287;
shift[164][26]=288;
shift[164][28]=289;
shift[164][29]=290;
shift[164][31]=291;
shift[164][32]=292;
shift[164][34]=293;
shift[164][36]=294;
shift[164][37]=295;
shift[164][38]=296;
shift[164][39]=297;
shift[164][55]=298;
shift[164][56]=299;
shift[165][9]=99;
shift[165][12]=300;
shift[165][14]=101;
shift[165][19]=102;
shift[165][22]=103;
shift[165][26]=104;
shift[165][28]=105;
shift[165][29]=106;
shift[165][31]=107;
shift[165][34]=108;
shift[166][24]=301;
shift[166][30]=112;
shift[166][32]=113;
shift[167][14]=72;
shift[167][19]=302;
shift[167][22]=74;
shift[167][26]=75;
shift[167][28]=76;
shift[167][31]=303;
shift[167][34]=79;
shift[168][14]=72;
shift[168][19]=302;
shift[168][22]=74;
shift[168][26]=75;
shift[168][28]=76;
shift[168][31]=304;
shift[168][34]=79;
shift[169][14]=72;
shift[169][19]=302;
shift[169][22]=74;
shift[169][26]=75;
shift[169][28]=76;
shift[169][34]=305;
shift[170][14]=72;
shift[170][19]=302;
shift[170][22]=74;
shift[170][26]=75;
shift[170][28]=76;
shift[170][34]=306;
shift[171][25]=162;
shift[172][25]=162;
shift[173][10]=307;
shift[175][22]=308;
shift[176][9]=309;
shift[176][14]=310;
shift[176][19]=311;
shift[176][22]=312;
shift[176][26]=313;
shift[176][28]=314;
shift[176][29]=315;
shift[176][31]=316;
shift[176][34]=317;
shift[176][36]=318;
shift[176][61]=319;
shift[176][64]=320;
shift[179][30]=321;
shift[179][32]=322;
shift[180][33]=323;
shift[180][35]=324;
shift[183][13]=325;
shift[183][25]=326;
shift[185][9]=173;
shift[185][14]=174;
shift[185][19]=175;
shift[185][22]=176;
shift[185][26]=177;
shift[185][28]=178;
shift[185][29]=179;
shift[185][31]=180;
shift[185][34]=181;
shift[185][36]=182;
shift[185][61]=327;
shift[185][64]=185;
shift[186][10]=328;
shift[188][22]=329;
shift[189][9]=309;
shift[189][14]=310;
shift[189][19]=311;
shift[189][22]=312;
shift[189][26]=313;
shift[189][28]=314;
shift[189][29]=330;
shift[189][31]=316;
shift[189][34]=317;
shift[189][36]=318;
shift[189][61]=331;
shift[189][64]=320;
shift[192][30]=332;
shift[192][32]=333;
shift[193][33]=334;
shift[193][35]=335;
shift[196][25]=336;
shift[196][43]=337;
shift[198][9]=186;
shift[198][14]=187;
shift[198][19]=188;
shift[198][22]=189;
shift[198][26]=190;
shift[198][28]=191;
shift[198][29]=192;
shift[198][31]=193;
shift[198][34]=194;
shift[198][36]=195;
shift[198][61]=338;
shift[198][64]=198;
shift[200][25]=339;
shift[200][53]=340;
shift[202][22]=341;
shift[203][14]=35;
shift[203][19]=36;
shift[203][22]=37;
shift[203][26]=38;
shift[203][28]=39;
shift[203][29]=342;
shift[203][31]=41;
shift[203][34]=42;
shift[206][30]=343;
shift[206][32]=344;
shift[207][33]=345;
shift[207][35]=346;
shift[210][13]=347;
shift[210][25]=348;
shift[211][15]=349;
shift[212][22]=350;
shift[213][14]=35;
shift[213][19]=36;
shift[213][22]=37;
shift[213][26]=38;
shift[213][28]=39;
shift[213][29]=351;
shift[213][31]=41;
shift[213][34]=42;
shift[216][30]=352;
shift[216][32]=353;
shift[217][33]=354;
shift[217][35]=355;
shift[219][9]=99;
shift[219][12]=356;
shift[219][14]=101;
shift[219][19]=102;
shift[219][22]=103;
shift[219][26]=104;
shift[219][28]=105;
shift[219][29]=106;
shift[219][31]=107;
shift[219][34]=108;
shift[220][24]=357;
shift[220][30]=112;
shift[220][32]=113;
shift[221][14]=88;
shift[221][19]=358;
shift[221][22]=90;
shift[221][26]=91;
shift[221][28]=92;
shift[221][31]=359;
shift[221][34]=95;
shift[222][14]=88;
shift[222][19]=358;
shift[222][22]=90;
shift[222][26]=91;
shift[222][28]=92;
shift[222][31]=360;
shift[222][34]=95;
shift[223][14]=88;
shift[223][19]=358;
shift[223][22]=90;
shift[223][26]=91;
shift[223][28]=92;
shift[223][34]=361;
shift[224][14]=88;
shift[224][19]=358;
shift[224][22]=90;
shift[224][26]=91;
shift[224][28]=92;
shift[224][34]=362;
shift[225][19]=363;
shift[226][19]=364;
shift[228][9]=365;
shift[228][14]=101;
shift[228][19]=102;
shift[228][22]=103;
shift[228][26]=104;
shift[228][28]=105;
shift[228][29]=106;
shift[228][31]=107;
shift[228][34]=108;
shift[229][9]=99;
shift[229][12]=366;
shift[229][14]=101;
shift[229][19]=102;
shift[229][22]=103;
shift[229][26]=104;
shift[229][28]=105;
shift[229][29]=106;
shift[229][31]=107;
shift[229][34]=108;
shift[230][24]=367;
shift[230][30]=112;
shift[230][32]=113;
shift[231][14]=101;
shift[231][19]=368;
shift[231][22]=103;
shift[231][26]=104;
shift[231][28]=105;
shift[231][31]=369;
shift[231][34]=108;
shift[232][14]=101;
shift[232][19]=368;
shift[232][22]=103;
shift[232][26]=104;
shift[232][28]=105;
shift[232][31]=370;
shift[232][34]=108;
shift[233][14]=101;
shift[233][19]=368;
shift[233][22]=103;
shift[233][26]=104;
shift[233][28]=105;
shift[233][34]=371;
shift[234][14]=101;
shift[234][19]=368;
shift[234][22]=103;
shift[234][26]=104;
shift[234][28]=105;
shift[234][34]=372;
shift[235][23]=373;
shift[235][26]=374;
shift[237][33]=114;
shift[237][35]=115;
shift[238][33]=114;
shift[238][35]=115;
shift[241][9]=375;
shift[241][14]=35;
shift[241][19]=376;
shift[241][22]=37;
shift[241][26]=38;
shift[241][28]=39;
shift[241][29]=377;
shift[241][31]=41;
shift[241][34]=42;
shift[242][9]=99;
shift[242][12]=378;
shift[242][14]=101;
shift[242][19]=102;
shift[242][22]=103;
shift[242][26]=104;
shift[242][28]=105;
shift[242][29]=106;
shift[242][31]=107;
shift[242][34]=108;
shift[243][24]=379;
shift[243][30]=112;
shift[243][32]=113;
shift[244][14]=124;
shift[244][19]=380;
shift[244][22]=126;
shift[244][26]=127;
shift[244][28]=128;
shift[244][31]=381;
shift[244][34]=132;
shift[245][14]=124;
shift[245][19]=380;
shift[245][22]=126;
shift[245][26]=127;
shift[245][28]=128;
shift[245][31]=382;
shift[245][34]=132;
shift[246][14]=124;
shift[246][19]=380;
shift[246][22]=126;
shift[246][26]=127;
shift[246][28]=128;
shift[246][34]=383;
shift[247][14]=124;
shift[247][19]=380;
shift[247][22]=126;
shift[247][26]=127;
shift[247][28]=128;
shift[247][34]=384;
shift[250][9]=123;
shift[250][14]=124;
shift[250][19]=125;
shift[250][22]=126;
shift[250][26]=127;
shift[250][28]=128;
shift[250][29]=129;
shift[250][31]=130;
shift[250][32]=131;
shift[250][34]=132;
shift[250][36]=133;
shift[250][37]=385;
shift[250][38]=135;
shift[250][39]=136;
shift[251][9]=123;
shift[251][14]=124;
shift[251][19]=125;
shift[251][22]=126;
shift[251][26]=127;
shift[251][28]=128;
shift[251][29]=129;
shift[251][31]=130;
shift[251][34]=132;
shift[251][36]=386;
shift[255][22]=387;
shift[256][14]=35;
shift[256][19]=36;
shift[256][22]=37;
shift[256][26]=38;
shift[256][28]=39;
shift[256][29]=388;
shift[256][31]=41;
shift[256][34]=42;
shift[259][30]=389;
shift[259][32]=390;
shift[260][33]=391;
shift[260][35]=392;
shift[262][24]=393;
shift[262][25]=228;
shift[265][33]=149;
shift[265][35]=150;
shift[266][33]=149;
shift[266][35]=150;
shift[268][30]=389;
shift[268][32]=390;
shift[269][30]=389;
shift[269][32]=390;
shift[270][30]=389;
shift[270][32]=390;
shift[271][30]=389;
shift[271][32]=390;
shift[272][30]=389;
shift[272][32]=390;
shift[273][30]=389;
shift[273][32]=390;
shift[276][24]=394;
shift[276][30]=112;
shift[276][32]=113;
shift[277][14]=151;
shift[277][19]=395;
shift[277][22]=153;
shift[277][26]=154;
shift[277][28]=155;
shift[277][31]=396;
shift[277][34]=158;
shift[278][14]=151;
shift[278][19]=395;
shift[278][22]=153;
shift[278][26]=154;
shift[278][28]=155;
shift[278][31]=397;
shift[278][34]=158;
shift[279][14]=151;
shift[279][19]=395;
shift[279][22]=153;
shift[279][26]=154;
shift[279][28]=155;
shift[279][34]=398;
shift[280][14]=151;
shift[280][19]=395;
shift[280][22]=153;
shift[280][26]=154;
shift[280][28]=155;
shift[280][34]=399;
shift[281][24]=400;
shift[282][24]=401;
shift[284][10]=402;
shift[286][22]=403;
shift[287][14]=35;
shift[287][19]=36;
shift[287][22]=37;
shift[287][26]=38;
shift[287][28]=39;
shift[287][29]=404;
shift[287][31]=41;
shift[287][34]=42;
shift[290][30]=405;
shift[290][32]=406;
shift[291][33]=407;
shift[291][35]=408;
shift[292][9]=284;
shift[292][14]=285;
shift[292][19]=286;
shift[292][22]=287;
shift[292][26]=288;
shift[292][28]=289;
shift[292][29]=290;
shift[292][31]=291;
shift[292][34]=293;
shift[292][36]=409;
shift[295][44]=410;
shift[296][22]=411;
shift[297][22]=412;
shift[298][22]=413;
shift[299][22]=414;
shift[300][24]=415;
shift[300][25]=228;
shift[303][33]=169;
shift[303][35]=170;
shift[304][33]=169;
shift[304][35]=170;
shift[307][9]=416;
shift[307][14]=417;
shift[307][19]=212;
shift[307][22]=213;
shift[307][26]=214;
shift[307][28]=215;
shift[307][29]=216;
shift[307][31]=217;
shift[307][34]=218;
shift[308][9]=99;
shift[308][12]=418;
shift[308][14]=101;
shift[308][19]=102;
shift[308][22]=103;
shift[308][26]=104;
shift[308][28]=105;
shift[308][29]=106;
shift[308][31]=107;
shift[308][34]=108;
shift[309][10]=419;
shift[311][22]=420;
shift[312][9]=309;
shift[312][14]=310;
shift[312][19]=311;
shift[312][22]=312;
shift[312][26]=313;
shift[312][28]=314;
shift[312][29]=421;
shift[312][31]=316;
shift[312][34]=317;
shift[312][36]=318;
shift[312][61]=422;
shift[312][64]=320;
shift[315][24]=423;
shift[315][30]=424;
shift[315][32]=425;
shift[316][33]=426;
shift[316][35]=427;
shift[319][62]=428;
shift[319][63]=429;
shift[320][9]=309;
shift[320][14]=430;
shift[320][19]=431;
shift[320][22]=432;
shift[320][26]=433;
shift[320][28]=434;
shift[320][29]=435;
shift[320][31]=436;
shift[320][34]=437;
shift[320][36]=318;
shift[320][61]=438;
shift[320][64]=320;
shift[321][14]=174;
shift[321][19]=439;
shift[321][22]=440;
shift[321][26]=177;
shift[321][28]=178;
shift[321][31]=441;
shift[321][34]=181;
shift[322][14]=174;
shift[322][19]=439;
shift[322][22]=440;
shift[322][26]=177;
shift[322][28]=178;
shift[322][31]=442;
shift[322][34]=181;
shift[323][14]=174;
shift[323][19]=439;
shift[323][22]=440;
shift[323][26]=177;
shift[323][28]=178;
shift[323][34]=443;
shift[324][14]=174;
shift[324][19]=439;
shift[324][22]=440;
shift[324][26]=177;
shift[324][28]=178;
shift[324][34]=444;
shift[326][9]=173;
shift[326][14]=174;
shift[326][19]=175;
shift[326][22]=176;
shift[326][26]=177;
shift[326][28]=178;
shift[326][29]=179;
shift[326][31]=180;
shift[326][34]=181;
shift[326][36]=182;
shift[326][61]=445;
shift[326][64]=185;
shift[328][9]=446;
shift[328][14]=447;
shift[328][19]=448;
shift[328][22]=449;
shift[328][26]=450;
shift[328][28]=451;
shift[328][29]=452;
shift[328][31]=453;
shift[328][34]=454;
shift[329][9]=99;
shift[329][12]=455;
shift[329][14]=101;
shift[329][19]=102;
shift[329][22]=103;
shift[329][26]=104;
shift[329][28]=105;
shift[329][29]=106;
shift[329][31]=107;
shift[329][34]=108;
shift[330][24]=456;
shift[330][30]=424;
shift[330][32]=425;
shift[331][62]=457;
shift[331][63]=458;
shift[332][14]=187;
shift[332][19]=459;
shift[332][22]=460;
shift[332][26]=190;
shift[332][28]=191;
shift[332][31]=461;
shift[332][34]=194;
shift[333][14]=187;
shift[333][19]=459;
shift[333][22]=460;
shift[333][26]=190;
shift[333][28]=191;
shift[333][31]=462;
shift[333][34]=194;
shift[334][14]=187;
shift[334][19]=459;
shift[334][22]=460;
shift[334][26]=190;
shift[334][28]=191;
shift[334][34]=463;
shift[335][14]=187;
shift[335][19]=459;
shift[335][22]=460;
shift[335][26]=190;
shift[335][28]=191;
shift[335][34]=464;
shift[336][9]=186;
shift[336][14]=187;
shift[336][19]=188;
shift[336][22]=189;
shift[336][26]=190;
shift[336][28]=191;
shift[336][29]=192;
shift[336][31]=193;
shift[336][34]=194;
shift[336][36]=195;
shift[336][61]=465;
shift[336][64]=198;
shift[339][9]=466;
shift[339][14]=201;
shift[339][19]=202;
shift[339][22]=203;
shift[339][26]=204;
shift[339][28]=205;
shift[339][29]=206;
shift[339][31]=207;
shift[339][34]=208;
shift[341][9]=99;
shift[341][12]=467;
shift[341][14]=101;
shift[341][19]=102;
shift[341][22]=103;
shift[341][26]=104;
shift[341][28]=105;
shift[341][29]=106;
shift[341][31]=107;
shift[341][34]=108;
shift[342][24]=468;
shift[342][30]=112;
shift[342][32]=113;
shift[343][14]=201;
shift[343][19]=469;
shift[343][22]=203;
shift[343][26]=204;
shift[343][28]=205;
shift[343][31]=470;
shift[343][34]=208;
shift[344][14]=201;
shift[344][19]=469;
shift[344][22]=203;
shift[344][26]=204;
shift[344][28]=205;
shift[344][31]=471;
shift[344][34]=208;
shift[345][14]=201;
shift[345][19]=469;
shift[345][22]=203;
shift[345][26]=204;
shift[345][28]=205;
shift[345][34]=472;
shift[346][14]=201;
shift[346][19]=469;
shift[346][22]=203;
shift[346][26]=204;
shift[346][28]=205;
shift[346][34]=473;
shift[348][9]=474;
shift[348][14]=417;
shift[348][19]=212;
shift[348][22]=213;
shift[348][26]=214;
shift[348][28]=215;
shift[348][29]=216;
shift[348][31]=217;
shift[348][34]=218;
shift[349][14]=475;
shift[350][9]=99;
shift[350][12]=476;
shift[350][14]=101;
shift[350][19]=102;
shift[350][22]=103;
shift[350][26]=104;
shift[350][28]=105;
shift[350][29]=106;
shift[350][31]=107;
shift[350][34]=108;
shift[351][24]=477;
shift[351][30]=112;
shift[351][32]=113;
shift[352][14]=417;
shift[352][19]=478;
shift[352][22]=213;
shift[352][26]=214;
shift[352][28]=215;
shift[352][31]=479;
shift[352][34]=218;
shift[353][14]=417;
shift[353][19]=478;
shift[353][22]=213;
shift[353][26]=214;
shift[353][28]=215;
shift[353][31]=480;
shift[353][34]=218;
shift[354][14]=417;
shift[354][19]=478;
shift[354][22]=213;
shift[354][26]=214;
shift[354][28]=215;
shift[354][34]=481;
shift[355][14]=417;
shift[355][19]=478;
shift[355][22]=213;
shift[355][26]=214;
shift[355][28]=215;
shift[355][34]=482;
shift[356][24]=483;
shift[356][25]=228;
shift[359][33]=223;
shift[359][35]=224;
shift[360][33]=223;
shift[360][35]=224;
shift[366][24]=484;
shift[366][25]=228;
shift[369][33]=233;
shift[369][35]=234;
shift[370][33]=233;
shift[370][35]=234;
shift[373][24]=485;
shift[373][27]=486;
shift[376][22]=487;
shift[377][30]=112;
shift[377][32]=113;
shift[378][24]=488;
shift[378][25]=228;
shift[381][33]=246;
shift[381][35]=247;
shift[382][33]=246;
shift[382][35]=247;
shift[385][24]=489;
shift[386][24]=490;
shift[387][9]=99;
shift[387][12]=491;
shift[387][14]=101;
shift[387][19]=102;
shift[387][22]=103;
shift[387][26]=104;
shift[387][28]=105;
shift[387][29]=106;
shift[387][31]=107;
shift[387][34]=108;
shift[388][24]=492;
shift[388][30]=112;
shift[388][32]=113;
shift[389][14]=254;
shift[389][19]=267;
shift[389][22]=256;
shift[389][26]=257;
shift[389][28]=258;
shift[389][31]=493;
shift[389][34]=261;
shift[390][14]=254;
shift[390][19]=267;
shift[390][22]=256;
shift[390][26]=257;
shift[390][28]=258;
shift[390][31]=494;
shift[390][34]=261;
shift[391][14]=254;
shift[391][19]=267;
shift[391][22]=256;
shift[391][26]=257;
shift[391][28]=258;
shift[391][34]=495;
shift[392][14]=254;
shift[392][19]=267;
shift[392][22]=256;
shift[392][26]=257;
shift[392][28]=258;
shift[392][34]=496;
shift[396][33]=279;
shift[396][35]=280;
shift[397][33]=279;
shift[397][35]=280;
shift[402][9]=497;
shift[402][14]=498;
shift[402][19]=499;
shift[402][22]=500;
shift[402][26]=501;
shift[402][28]=502;
shift[402][29]=503;
shift[402][31]=504;
shift[402][34]=505;
shift[403][9]=99;
shift[403][12]=506;
shift[403][14]=101;
shift[403][19]=102;
shift[403][22]=103;
shift[403][26]=104;
shift[403][28]=105;
shift[403][29]=106;
shift[403][31]=107;
shift[403][34]=108;
shift[404][24]=507;
shift[404][30]=112;
shift[404][32]=113;
shift[405][14]=285;
shift[405][19]=508;
shift[405][22]=287;
shift[405][26]=288;
shift[405][28]=289;
shift[405][31]=509;
shift[405][34]=293;
shift[406][14]=285;
shift[406][19]=508;
shift[406][22]=287;
shift[406][26]=288;
shift[406][28]=289;
shift[406][31]=510;
shift[406][34]=293;
shift[407][14]=285;
shift[407][19]=508;
shift[407][22]=287;
shift[407][26]=288;
shift[407][28]=289;
shift[407][34]=511;
shift[408][14]=285;
shift[408][19]=508;
shift[408][22]=287;
shift[408][26]=288;
shift[408][28]=289;
shift[408][34]=512;
shift[410][9]=53;
shift[410][14]=54;
shift[410][19]=55;
shift[410][22]=56;
shift[410][26]=57;
shift[410][28]=58;
shift[410][29]=59;
shift[410][31]=60;
shift[410][32]=61;
shift[410][34]=62;
shift[410][36]=63;
shift[410][37]=64;
shift[410][38]=65;
shift[410][39]=66;
shift[410][41]=513;
shift[410][45]=68;
shift[410][46]=69;
shift[410][47]=70;
shift[411][9]=123;
shift[411][14]=124;
shift[411][19]=125;
shift[411][22]=126;
shift[411][26]=127;
shift[411][28]=128;
shift[411][29]=129;
shift[411][31]=130;
shift[411][32]=131;
shift[411][34]=132;
shift[411][36]=133;
shift[411][37]=514;
shift[411][38]=135;
shift[411][39]=136;
shift[412][9]=123;
shift[412][14]=124;
shift[412][19]=125;
shift[412][22]=126;
shift[412][26]=127;
shift[412][28]=128;
shift[412][29]=129;
shift[412][31]=130;
shift[412][34]=132;
shift[412][36]=515;
shift[413][9]=516;
shift[413][14]=517;
shift[413][19]=518;
shift[413][22]=519;
shift[413][26]=520;
shift[413][28]=521;
shift[413][29]=522;
shift[413][31]=523;
shift[413][34]=524;
shift[414][9]=525;
shift[414][14]=526;
shift[414][19]=527;
shift[414][22]=528;
shift[414][26]=529;
shift[414][28]=530;
shift[414][29]=531;
shift[414][31]=532;
shift[414][34]=533;
shift[414][36]=534;
shift[418][24]=535;
shift[418][25]=228;
shift[419][9]=536;
shift[419][14]=537;
shift[419][19]=538;
shift[419][22]=539;
shift[419][26]=540;
shift[419][28]=541;
shift[419][29]=542;
shift[419][31]=543;
shift[419][34]=544;
shift[420][9]=99;
shift[420][12]=545;
shift[420][14]=101;
shift[420][19]=102;
shift[420][22]=103;
shift[420][26]=104;
shift[420][28]=105;
shift[420][29]=106;
shift[420][31]=107;
shift[420][34]=108;
shift[421][24]=546;
shift[421][30]=424;
shift[421][32]=425;
shift[422][62]=547;
shift[422][63]=548;
shift[424][14]=310;


shift[424][19]=549;
shift[424][22]=550;
shift[424][26]=313;
shift[424][28]=314;
shift[424][31]=551;
shift[424][34]=317;
shift[425][14]=310;
shift[425][19]=549;
shift[425][22]=550;
shift[425][26]=313;
shift[425][28]=314;
shift[425][31]=552;
shift[425][34]=317;
shift[426][14]=310;
shift[426][19]=549;
shift[426][22]=550;
shift[426][26]=313;
shift[426][28]=314;
shift[426][34]=553;
shift[427][14]=310;
shift[427][19]=549;
shift[427][22]=550;
shift[427][26]=313;
shift[427][28]=314;
shift[427][34]=554;
shift[428][9]=123;
shift[428][14]=124;
shift[428][19]=125;
shift[428][22]=555;
shift[428][26]=127;
shift[428][28]=128;
shift[428][29]=129;
shift[428][31]=130;
shift[428][34]=132;
shift[428][36]=556;
shift[428][61]=557;
shift[428][64]=558;
shift[429][9]=123;
shift[429][14]=124;
shift[429][19]=125;
shift[429][22]=555;
shift[429][26]=127;
shift[429][28]=128;
shift[429][29]=129;
shift[429][31]=130;
shift[429][34]=132;
shift[429][36]=556;
shift[429][61]=559;
shift[429][64]=558;
shift[431][22]=420;
shift[432][9]=309;
shift[432][14]=310;
shift[432][19]=311;
shift[432][22]=312;
shift[432][26]=313;
shift[432][28]=314;
shift[432][29]=560;
shift[432][31]=316;
shift[432][34]=317;
shift[432][36]=318;
shift[432][61]=422;
shift[432][64]=320;
shift[435][30]=561;
shift[435][32]=562;
shift[436][33]=563;
shift[436][35]=564;
shift[440][14]=35;
shift[440][19]=36;
shift[440][22]=37;
shift[440][26]=38;
shift[440][28]=39;
shift[440][29]=565;
shift[440][31]=41;
shift[440][34]=42;
shift[441][33]=323;
shift[441][35]=324;
shift[442][33]=323;
shift[442][35]=324;
shift[448][22]=566;
shift[449][14]=35;
shift[449][19]=36;
shift[449][22]=37;
shift[449][26]=38;
shift[449][28]=39;
shift[449][29]=567;
shift[449][31]=41;
shift[449][34]=42;
shift[452][30]=568;
shift[452][32]=569;
shift[453][33]=570;
shift[453][35]=571;
shift[455][24]=572;
shift[455][25]=228;
shift[457][9]=123;
shift[457][14]=124;
shift[457][19]=125;
shift[457][22]=555;
shift[457][26]=127;
shift[457][28]=128;
shift[457][29]=129;
shift[457][31]=130;
shift[457][34]=132;
shift[457][36]=556;
shift[457][61]=573;
shift[457][64]=558;
shift[458][9]=123;
shift[458][14]=124;
shift[458][19]=125;
shift[458][22]=555;
shift[458][26]=127;
shift[458][28]=128;
shift[458][29]=129;
shift[458][31]=130;
shift[458][34]=132;
shift[458][36]=556;
shift[458][61]=574;
shift[458][64]=558;
shift[460][14]=35;
shift[460][19]=36;
shift[460][22]=37;
shift[460][26]=38;
shift[460][28]=39;
shift[460][29]=575;
shift[460][31]=41;
shift[460][34]=42;
shift[461][33]=334;
shift[461][35]=335;
shift[462][33]=334;
shift[462][35]=335;
shift[467][24]=576;
shift[467][25]=228;
shift[470][33]=345;
shift[470][35]=346;
shift[471][33]=345;
shift[471][35]=346;
shift[475][13]=577;
shift[476][24]=578;
shift[476][25]=228;
shift[479][33]=354;
shift[479][35]=355;
shift[480][33]=354;
shift[480][35]=355;
shift[486][26]=579;
shift[487][9]=99;
shift[487][12]=580;
shift[487][14]=101;
shift[487][19]=102;
shift[487][22]=103;
shift[487][26]=104;
shift[487][28]=105;
shift[487][29]=106;
shift[487][31]=107;
shift[487][34]=108;
shift[491][24]=581;
shift[491][25]=228;
shift[493][33]=391;
shift[493][35]=392;
shift[494][33]=391;
shift[494][35]=392;
shift[499][22]=582;
shift[500][14]=35;
shift[500][19]=36;
shift[500][22]=37;
shift[500][26]=38;
shift[500][28]=39;
shift[500][29]=583;
shift[500][31]=41;
shift[500][34]=42;
shift[503][30]=584;
shift[503][32]=585;
shift[504][33]=586;
shift[504][35]=587;
shift[506][24]=588;
shift[506][25]=228;
shift[509][33]=407;
shift[509][35]=408;
shift[510][33]=407;
shift[510][35]=408;
shift[513][25]=162;
shift[514][24]=589;
shift[515][24]=590;
shift[516][17]=591;
shift[516][24]=592;
shift[518][22]=593;
shift[519][14]=35;
shift[519][19]=36;
shift[519][22]=37;
shift[519][26]=38;
shift[519][28]=39;
shift[519][29]=594;
shift[519][31]=41;
shift[519][34]=42;
shift[522][30]=595;
shift[522][32]=596;
shift[523][33]=597;
shift[523][35]=598;
shift[525][10]=599;
shift[527][22]=600;
shift[528][14]=35;
shift[528][19]=36;
shift[528][22]=37;
shift[528][26]=38;
shift[528][28]=39;
shift[528][29]=601;
shift[528][31]=41;
shift[528][34]=42;
shift[531][30]=602;
shift[531][32]=603;
shift[532][33]=604;
shift[532][35]=605;
shift[534][24]=606;
shift[534][57]=607;
shift[538][22]=608;
shift[539][14]=35;
shift[539][19]=36;
shift[539][22]=37;
shift[539][26]=38;
shift[539][28]=39;
shift[539][29]=609;
shift[539][31]=41;
shift[539][34]=42;
shift[542][30]=610;
shift[542][32]=611;
shift[543][33]=612;
shift[543][35]=613;
shift[545][24]=614;
shift[545][25]=228;
shift[547][9]=123;
shift[547][14]=124;
shift[547][19]=125;
shift[547][22]=555;
shift[547][26]=127;
shift[547][28]=128;
shift[547][29]=129;
shift[547][31]=130;
shift[547][34]=132;
shift[547][36]=556;
shift[547][61]=615;
shift[547][64]=558;
shift[548][9]=123;
shift[548][14]=124;
shift[548][19]=125;
shift[548][22]=555;
shift[548][26]=127;
shift[548][28]=128;
shift[548][29]=129;
shift[548][31]=130;
shift[548][34]=132;
shift[548][36]=556;
shift[548][61]=616;
shift[548][64]=558;
shift[550][14]=35;
shift[550][19]=36;
shift[550][22]=37;
shift[550][26]=38;
shift[550][28]=39;
shift[550][29]=617;
shift[550][31]=41;
shift[550][34]=42;
shift[551][33]=426;
shift[551][35]=427;
shift[552][33]=426;
shift[552][35]=427;
shift[555][9]=309;
shift[555][14]=310;
shift[555][19]=311;
shift[555][22]=312;
shift[555][26]=313;
shift[555][28]=314;
shift[555][29]=618;
shift[555][31]=316;
shift[555][34]=317;
shift[555][36]=318;
shift[555][61]=619;
shift[555][64]=320;
shift[557][24]=620;
shift[558][9]=123;
shift[558][14]=124;
shift[558][19]=125;
shift[558][22]=555;
shift[558][26]=127;
shift[558][28]=128;
shift[558][29]=129;
shift[558][31]=130;
shift[558][34]=132;
shift[558][36]=556;
shift[558][61]=621;
shift[558][64]=558;
shift[559][24]=622;
shift[560][24]=623;
shift[560][30]=424;
shift[560][32]=425;
shift[561][14]=430;
shift[561][19]=624;
shift[561][22]=625;
shift[561][26]=433;
shift[561][28]=434;
shift[561][31]=626;
shift[561][34]=437;
shift[562][14]=430;
shift[562][19]=624;
shift[562][22]=625;
shift[562][26]=433;
shift[562][28]=434;
shift[562][31]=627;
shift[562][34]=437;
shift[563][14]=430;
shift[563][19]=624;
shift[563][22]=625;
shift[563][26]=433;
shift[563][28]=434;
shift[563][34]=628;
shift[564][14]=430;
shift[564][19]=624;
shift[564][22]=625;
shift[564][26]=433;
shift[564][28]=434;
shift[564][34]=629;
shift[565][24]=423;
shift[565][30]=112;
shift[565][32]=113;
shift[566][9]=99;
shift[566][12]=630;
shift[566][14]=101;
shift[566][19]=102;
shift[566][22]=103;
shift[566][26]=104;
shift[566][28]=105;
shift[566][29]=106;
shift[566][31]=107;
shift[566][34]=108;
shift[567][24]=631;
shift[567][30]=112;
shift[567][32]=113;
shift[568][14]=447;
shift[568][19]=632;
shift[568][22]=449;
shift[568][26]=450;
shift[568][28]=451;
shift[568][31]=633;
shift[568][34]=454;
shift[569][14]=447;
shift[569][19]=632;
shift[569][22]=449;
shift[569][26]=450;
shift[569][28]=451;
shift[569][31]=634;
shift[569][34]=454;
shift[570][14]=447;
shift[570][19]=632;
shift[570][22]=449;
shift[570][26]=450;
shift[570][28]=451;
shift[570][34]=635;
shift[571][14]=447;
shift[571][19]=632;
shift[571][22]=449;
shift[571][26]=450;
shift[571][28]=451;
shift[571][34]=636;
shift[573][24]=637;
shift[574][24]=638;
shift[575][24]=456;
shift[575][30]=112;
shift[575][32]=113;
shift[580][24]=639;
shift[580][25]=228;
shift[582][9]=99;
shift[582][12]=640;
shift[582][14]=101;
shift[582][19]=102;
shift[582][22]=103;
shift[582][26]=104;
shift[582][28]=105;
shift[582][29]=106;
shift[582][31]=107;
shift[582][34]=108;
shift[583][24]=641;
shift[583][30]=112;
shift[583][32]=113;
shift[584][14]=498;
shift[584][19]=642;
shift[584][22]=500;
shift[584][26]=501;
shift[584][28]=502;
shift[584][31]=643;
shift[584][34]=505;
shift[585][14]=498;
shift[585][19]=642;
shift[585][22]=500;
shift[585][26]=501;
shift[585][28]=502;
shift[585][31]=644;
shift[585][34]=505;
shift[586][14]=498;
shift[586][19]=642;
shift[586][22]=500;
shift[586][26]=501;
shift[586][28]=502;
shift[586][34]=645;
shift[587][14]=498;
shift[587][19]=642;
shift[587][22]=500;
shift[587][26]=501;
shift[587][28]=502;
shift[587][34]=646;
shift[591][11]=647;
shift[593][9]=99;
shift[593][12]=648;
shift[593][14]=101;
shift[593][19]=102;
shift[593][22]=103;
shift[593][26]=104;
shift[593][28]=105;
shift[593][29]=106;
shift[593][31]=107;
shift[593][34]=108;
shift[594][24]=649;
shift[594][30]=112;
shift[594][32]=113;
shift[595][14]=517;
shift[595][19]=650;
shift[595][22]=519;
shift[595][26]=520;
shift[595][28]=521;
shift[595][31]=651;
shift[595][34]=524;
shift[596][14]=517;
shift[596][19]=650;
shift[596][22]=519;
shift[596][26]=520;
shift[596][28]=521;
shift[596][31]=652;
shift[596][34]=524;
shift[597][14]=517;
shift[597][19]=650;
shift[597][22]=519;
shift[597][26]=520;
shift[597][28]=521;
shift[597][34]=653;
shift[598][14]=517;
shift[598][19]=650;
shift[598][22]=519;
shift[598][26]=520;
shift[598][28]=521;
shift[598][34]=654;
shift[599][9]=655;
shift[599][14]=656;
shift[599][19]=657;
shift[599][22]=658;
shift[599][26]=659;
shift[599][28]=660;
shift[599][29]=661;
shift[599][31]=662;
shift[599][34]=663;
shift[600][9]=99;
shift[600][12]=664;
shift[600][14]=101;
shift[600][19]=102;
shift[600][22]=103;
shift[600][26]=104;
shift[600][28]=105;
shift[600][29]=106;
shift[600][31]=107;
shift[600][34]=108;
shift[601][24]=665;
shift[601][30]=112;
shift[601][32]=113;
shift[602][14]=526;
shift[602][19]=666;
shift[602][22]=528;
shift[602][26]=529;
shift[602][28]=530;
shift[602][31]=667;
shift[602][34]=533;
shift[603][14]=526;
shift[603][19]=666;
shift[603][22]=528;
shift[603][26]=529;
shift[603][28]=530;
shift[603][31]=668;
shift[603][34]=533;
shift[604][14]=526;
shift[604][19]=666;
shift[604][22]=528;
shift[604][26]=529;
shift[604][28]=530;
shift[604][34]=669;
shift[605][14]=526;
shift[605][19]=666;
shift[605][22]=528;
shift[605][26]=529;
shift[605][28]=530;
shift[605][34]=670;
shift[606][10]=671;
shift[607][9]=672;
shift[607][14]=673;
shift[607][19]=674;
shift[607][22]=675;
shift[607][26]=676;
shift[607][28]=677;
shift[607][29]=678;
shift[607][31]=679;
shift[607][32]=680;
shift[607][34]=681;
shift[607][36]=682;
shift[607][37]=683;
shift[607][38]=684;
shift[607][39]=685;
shift[607][41]=686;
shift[607][45]=687;
shift[607][46]=688;
shift[607][47]=689;
shift[608][9]=99;
shift[608][12]=690;
shift[608][14]=101;
shift[608][19]=102;
shift[608][22]=103;
shift[608][26]=104;
shift[608][28]=105;
shift[608][29]=106;
shift[608][31]=107;
shift[608][34]=108;
shift[609][24]=691;
shift[609][30]=112;
shift[609][32]=113;
shift[610][14]=537;
shift[610][19]=692;
shift[610][22]=539;
shift[610][26]=540;
shift[610][28]=541;
shift[610][31]=693;
shift[610][34]=544;
shift[611][14]=537;
shift[611][19]=692;
shift[611][22]=539;
shift[611][26]=540;
shift[611][28]=541;
shift[611][31]=694;
shift[611][34]=544;
shift[612][14]=537;
shift[612][19]=692;
shift[612][22]=539;
shift[612][26]=540;
shift[612][28]=541;
shift[612][34]=695;
shift[613][14]=537;
shift[613][19]=692;
shift[613][22]=539;
shift[613][26]=540;
shift[613][28]=541;
shift[613][34]=696;
shift[615][24]=697;
shift[616][24]=698;
shift[617][24]=546;
shift[617][30]=112;
shift[617][32]=113;
shift[618][24]=379;
shift[618][30]=424;
shift[618][32]=425;
shift[619][62]=699;
shift[619][63]=700;
shift[625][14]=35;
shift[625][19]=36;
shift[625][22]=37;
shift[625][26]=38;
shift[625][28]=39;
shift[625][29]=701;
shift[625][31]=41;
shift[625][34]=42;
shift[626][33]=563;
shift[626][35]=564;
shift[627][33]=563;
shift[627][35]=564;
shift[630][24]=702;
shift[630][25]=228;
shift[633][33]=570;
shift[633][35]=571;
shift[634][33]=570;
shift[634][35]=571;
shift[640][24]=703;
shift[640][25]=228;
shift[643][33]=586;
shift[643][35]=587;
shift[644][33]=586;
shift[644][35]=587;
shift[647][26]=704;
shift[648][24]=705;
shift[648][25]=228;
shift[651][33]=597;
shift[651][35]=598;
shift[652][33]=597;
shift[652][35]=598;
shift[657][22]=706;
shift[658][14]=35;
shift[658][19]=36;
shift[658][22]=37;
shift[658][26]=38;
shift[658][28]=39;
shift[658][29]=707;
shift[658][31]=41;
shift[658][34]=42;
shift[661][30]=708;
shift[661][32]=709;
shift[662][33]=710;
shift[662][35]=711;
shift[664][24]=712;
shift[664][25]=228;
shift[667][33]=604;
shift[667][35]=605;
shift[668][33]=604;
shift[668][35]=605;
shift[671][14]=713;
shift[671][19]=714;
shift[671][22]=715;
shift[671][26]=716;
shift[671][28]=717;
shift[671][29]=718;
shift[671][31]=719;
shift[671][34]=720;
shift[672][10]=721;
shift[674][22]=722;
shift[675][14]=35;
shift[675][19]=36;
shift[675][22]=37;
shift[675][26]=38;
shift[675][28]=39;
shift[675][29]=723;
shift[675][31]=41;
shift[675][34]=42;
shift[678][30]=724;
shift[678][32]=725;
shift[678][48]=726;
shift[678][49]=727;
shift[678][50]=728;
shift[678][51]=729;
shift[678][52]=730;
shift[678][53]=731;
shift[679][33]=732;
shift[679][35]=733;
shift[680][9]=672;
shift[680][14]=734;
shift[680][19]=735;
shift[680][22]=736;
shift[680][26]=737;
shift[680][28]=738;
shift[680][29]=739;
shift[680][31]=740;
shift[680][34]=741;
shift[680][36]=742;
shift[684][22]=743;
shift[685][22]=744;
shift[686][24]=745;
shift[686][25]=746;
shift[688][9]=672;
shift[688][14]=734;
shift[688][19]=735;
shift[688][22]=736;
shift[688][26]=737;
shift[688][28]=738;
shift[688][29]=739;
shift[688][31]=740;
shift[688][32]=680;
shift[688][34]=741;
shift[688][36]=682;
shift[688][37]=747;
shift[688][38]=684;
shift[688][39]=685;
shift[690][24]=748;
shift[690][25]=228;
shift[693][33]=612;
shift[693][35]=613;
shift[694][33]=612;
shift[694][35]=613;
shift[699][9]=123;
shift[699][14]=124;
shift[699][19]=125;
shift[699][22]=555;
shift[699][26]=127;
shift[699][28]=128;
shift[699][29]=129;
shift[699][31]=130;
shift[699][34]=132;
shift[699][36]=556;
shift[699][61]=749;
shift[699][64]=558;
shift[700][9]=123;
shift[700][14]=124;
shift[700][19]=125;
shift[700][22]=555;
shift[700][26]=127;
shift[700][28]=128;
shift[700][29]=129;
shift[700][31]=130;
shift[700][34]=132;
shift[700][36]=556;
shift[700][61]=750;
shift[700][64]=558;
shift[701][24]=623;
shift[701][30]=112;
shift[701][32]=113;
shift[704][17]=751;
shift[706][9]=99;
shift[706][12]=752;
shift[706][14]=101;
shift[706][19]=102;
shift[706][22]=103;
shift[706][26]=104;
shift[706][28]=105;
shift[706][29]=106;
shift[706][31]=107;
shift[706][34]=108;
shift[707][24]=753;
shift[707][30]=112;
shift[707][32]=113;
shift[708][14]=656;
shift[708][19]=754;
shift[708][22]=658;
shift[708][26]=659;
shift[708][28]=660;
shift[708][31]=755;
shift[708][34]=663;
shift[709][14]=656;
shift[709][19]=754;
shift[709][22]=658;
shift[709][26]=659;
shift[709][28]=660;
shift[709][31]=756;
shift[709][34]=663;
shift[710][14]=656;
shift[710][19]=754;
shift[710][22]=658;
shift[710][26]=659;
shift[710][28]=660;
shift[710][34]=757;
shift[711][14]=656;
shift[711][19]=754;
shift[711][22]=658;
shift[711][26]=659;
shift[711][28]=660;
shift[711][34]=758;
shift[715][14]=35;
shift[715][19]=36;
shift[715][22]=37;
shift[715][26]=38;
shift[715][28]=39;
shift[715][29]=759;
shift[715][31]=41;
shift[715][34]=42;
shift[718][30]=760;
shift[718][32]=761;
shift[719][33]=762;
shift[719][35]=763;
shift[721][9]=764;
shift[721][14]=101;
shift[721][19]=102;
shift[721][22]=103;
shift[721][26]=104;
shift[721][28]=105;
shift[721][29]=106;
shift[721][31]=107;
shift[721][34]=108;
shift[722][9]=99;
shift[722][12]=765;
shift[722][14]=101;
shift[722][19]=102;
shift[722][22]=103;
shift[722][26]=104;
shift[722][28]=105;
shift[722][29]=106;
shift[722][31]=107;
shift[722][34]=108;
shift[723][24]=766;
shift[723][30]=112;
shift[723][32]=113;
shift[724][14]=673;
shift[724][19]=767;
shift[724][22]=675;
shift[724][26]=676;
shift[724][28]=677;
shift[724][31]=768;
shift[724][34]=681;
shift[725][14]=673;
shift[725][19]=767;
shift[725][22]=675;
shift[725][26]=676;
shift[725][28]=677;
shift[725][31]=769;
shift[725][34]=681;
shift[726][14]=101;
shift[726][19]=368;
shift[726][22]=103;
shift[726][26]=104;
shift[726][28]=105;
shift[726][29]=770;
shift[726][31]=107;
shift[726][34]=108;
shift[727][14]=101;
shift[727][19]=368;
shift[727][22]=103;
shift[727][26]=104;
shift[727][28]=105;
shift[727][29]=771;
shift[727][31]=107;
shift[727][34]=108;
shift[728][14]=101;
shift[728][19]=368;
shift[728][22]=103;
shift[728][26]=104;
shift[728][28]=105;
shift[728][29]=772;
shift[728][31]=107;
shift[728][34]=108;
shift[729][14]=101;
shift[729][19]=368;
shift[729][22]=103;
shift[729][26]=104;
shift[729][28]=105;
shift[729][29]=773;
shift[729][31]=107;
shift[729][34]=108;
shift[730][14]=101;
shift[730][19]=368;
shift[730][22]=103;
shift[730][26]=104;
shift[730][28]=105;
shift[730][29]=774;
shift[730][31]=107;
shift[730][34]=108;
shift[731][14]=101;
shift[731][19]=368;
shift[731][22]=103;
shift[731][26]=104;
shift[731][28]=105;
shift[731][29]=775;
shift[731][31]=107;
shift[731][34]=108;
shift[732][14]=673;
shift[732][19]=767;
shift[732][22]=675;
shift[732][26]=676;
shift[732][28]=677;
shift[732][34]=776;
shift[733][14]=673;
shift[733][19]=767;
shift[733][22]=675;
shift[733][26]=676;
shift[733][28]=677;
shift[733][34]=777;
shift[735][22]=722;
shift[736][14]=35;
shift[736][19]=36;
shift[736][22]=37;
shift[736][26]=38;
shift[736][28]=39;
shift[736][29]=778;
shift[736][31]=41;
shift[736][34]=42;
shift[739][30]=779;
shift[739][32]=780;
shift[740][33]=781;
shift[740][35]=782;
shift[743][9]=123;
shift[743][14]=124;
shift[743][19]=125;
shift[743][22]=126;
shift[743][26]=127;
shift[743][28]=128;
shift[743][29]=129;
shift[743][31]=130;
shift[743][32]=131;
shift[743][34]=132;
shift[743][36]=133;
shift[743][37]=783;
shift[743][38]=135;
shift[743][39]=136;
shift[744][9]=123;
shift[744][14]=124;
shift[744][19]=125;
shift[744][22]=126;
shift[744][26]=127;
shift[744][28]=128;
shift[744][29]=129;
shift[744][31]=130;
shift[744][34]=132;
shift[744][36]=784;
shift[745][10]=785;
shift[746][9]=672;
shift[746][14]=673;
shift[746][19]=674;
shift[746][22]=675;
shift[746][26]=676;
shift[746][28]=677;
shift[746][29]=678;
shift[746][31]=679;
shift[746][32]=680;
shift[746][34]=681;
shift[746][36]=682;
shift[746][37]=683;
shift[746][38]=684;
shift[746][39]=685;
shift[746][45]=786;
shift[746][46]=688;
shift[746][47]=689;
shift[749][24]=787;
shift[750][24]=788;
shift[751][9]=789;
shift[751][14]=790;
shift[751][19]=791;
shift[751][22]=792;
shift[751][26]=793;
shift[751][28]=794;
shift[751][29]=795;
shift[751][31]=796;
shift[751][34]=797;
shift[751][36]=798;
shift[752][24]=799;
shift[752][25]=228;
shift[755][33]=710;
shift[755][35]=711;
shift[756][33]=710;
shift[756][35]=711;
shift[759][24]=800;
shift[759][30]=112;
shift[759][32]=113;
shift[760][14]=713;
shift[760][19]=714;
shift[760][22]=715;
shift[760][26]=716;
shift[760][28]=717;
shift[760][31]=801;
shift[760][34]=720;
shift[761][14]=713;
shift[761][19]=714;
shift[761][22]=715;
shift[761][26]=716;
shift[761][28]=717;
shift[761][31]=802;
shift[761][34]=720;
shift[762][14]=713;
shift[762][19]=714;
shift[762][22]=715;
shift[762][26]=716;
shift[762][28]=717;
shift[762][34]=803;
shift[763][14]=713;
shift[763][19]=714;
shift[763][22]=715;
shift[763][26]=716;
shift[763][28]=717;
shift[763][34]=804;
shift[765][24]=805;
shift[765][25]=228;
shift[768][33]=732;
shift[768][35]=733;
shift[769][33]=732;
shift[769][35]=733;
shift[770][30]=231;
shift[770][32]=232;
shift[771][30]=231;
shift[771][32]=232;
shift[772][30]=231;
shift[772][32]=232;
shift[773][30]=231;
shift[773][32]=232;
shift[774][30]=231;
shift[774][32]=232;
shift[775][30]=231;
shift[775][32]=232;
shift[778][24]=806;
shift[778][30]=112;
shift[778][32]=113;
shift[779][14]=734;
shift[779][19]=807;
shift[779][22]=736;
shift[779][26]=737;
shift[779][28]=738;
shift[779][31]=808;
shift[779][34]=741;
shift[780][14]=734;
shift[780][19]=807;
shift[780][22]=736;
shift[780][26]=737;
shift[780][28]=738;
shift[780][31]=809;
shift[780][34]=741;
shift[781][14]=734;
shift[781][19]=807;
shift[781][22]=736;
shift[781][26]=737;
shift[781][28]=738;
shift[781][34]=810;
shift[782][14]=734;
shift[782][19]=807;
shift[782][22]=736;
shift[782][26]=737;
shift[782][28]=738;
shift[782][34]=811;
shift[783][24]=812;
shift[784][24]=813;
shift[785][14]=713;
shift[785][19]=714;
shift[785][22]=715;
shift[785][26]=716;
shift[785][28]=717;
shift[785][29]=814;
shift[785][31]=719;
shift[785][34]=720;
shift[789][10]=815;
shift[791][22]=816;
shift[792][14]=35;
shift[792][19]=36;
shift[792][22]=37;
shift[792][26]=38;
shift[792][28]=39;
shift[792][29]=817;
shift[792][31]=41;
shift[792][34]=42;
shift[795][30]=818;
shift[795][32]=819;
shift[796][33]=820;
shift[796][35]=821;
shift[798][13]=822;
shift[801][33]=762;
shift[801][35]=763;
shift[802][33]=762;
shift[802][35]=763;
shift[808][33]=781;
shift[808][35]=782;
shift[809][33]=781;
shift[809][35]=782;
shift[814][30]=760;
shift[814][32]=761;
shift[815][9]=823;
shift[815][14]=824;
shift[815][19]=825;
shift[815][22]=826;
shift[815][26]=827;
shift[815][28]=828;
shift[815][29]=829;
shift[815][31]=830;
shift[815][34]=831;
shift[816][9]=99;
shift[816][12]=832;
shift[816][14]=101;
shift[816][19]=102;
shift[816][22]=103;
shift[816][26]=104;
shift[816][28]=105;
shift[816][29]=106;
shift[816][31]=107;
shift[816][34]=108;
shift[817][24]=833;
shift[817][30]=112;
shift[817][32]=113;
shift[818][14]=790;
shift[818][19]=834;
shift[818][22]=792;
shift[818][26]=793;
shift[818][28]=794;
shift[818][31]=835;
shift[818][34]=797;
shift[819][14]=790;
shift[819][19]=834;
shift[819][22]=792;
shift[819][26]=793;
shift[819][28]=794;
shift[819][31]=836;
shift[819][34]=797;
shift[820][14]=790;
shift[820][19]=834;
shift[820][22]=792;
shift[820][26]=793;
shift[820][28]=794;
shift[820][34]=837;
shift[821][14]=790;
shift[821][19]=834;
shift[821][22]=792;
shift[821][26]=793;
shift[821][28]=794;
shift[821][34]=838;
shift[822][24]=839;
shift[825][22]=840;
shift[826][14]=35;
shift[826][19]=36;
shift[826][22]=37;
shift[826][26]=38;
shift[826][28]=39;
shift[826][29]=841;
shift[826][31]=41;
shift[826][34]=42;
shift[829][30]=842;
shift[829][32]=843;
shift[830][33]=844;
shift[830][35]=845;
shift[832][24]=846;
shift[832][25]=228;
shift[835][33]=820;
shift[835][35]=821;
shift[836][33]=820;
shift[836][35]=821;
shift[840][9]=99;
shift[840][12]=847;
shift[840][14]=101;
shift[840][19]=102;
shift[840][22]=103;
shift[840][26]=104;
shift[840][28]=105;
shift[840][29]=106;
shift[840][31]=107;
shift[840][34]=108;
shift[841][24]=848;
shift[841][30]=112;
shift[841][32]=113;
shift[842][14]=824;
shift[842][19]=849;
shift[842][22]=826;
shift[842][26]=827;
shift[842][28]=828;
shift[842][31]=850;
shift[842][34]=831;
shift[843][14]=824;
shift[843][19]=849;
shift[843][22]=826;
shift[843][26]=827;
shift[843][28]=828;
shift[843][31]=851;
shift[843][34]=831;
shift[844][14]=824;
shift[844][19]=849;
shift[844][22]=826;
shift[844][26]=827;
shift[844][28]=828;
shift[844][34]=852;
shift[845][14]=824;
shift[845][19]=849;
shift[845][22]=826;
shift[845][26]=827;
shift[845][28]=828;
shift[845][34]=853;
shift[847][24]=854;
shift[847][25]=228;
shift[850][33]=844;
shift[850][35]=845;
shift[851][33]=844;
shift[851][35]=845;
reduce[1][65]=0;
reduce[3][3]=3;
reduce[4][3]=4;
reduce[5][3]=5;
reduce[6][3]=6;
reduce[7][3]=7;
reduce[8][3]=33;
reduce[8][40]=33;
reduce[9][10]=19;
reduce[9][30]=19;
reduce[9][32]=19;
reduce[9][33]=19;
reduce[9][35]=19;
reduce[9][3]=19;
reduce[9][40]=19;
reduce[11][17]=13;
reduce[11][25]=13;
reduce[11][10]=17;
reduce[11][30]=17;
reduce[11][32]=17;
reduce[11][33]=17;
reduce[11][35]=17;
reduce[11][3]=17;
reduce[11][40]=17;
reduce[14][10]=18;
reduce[14][30]=18;
reduce[14][32]=18;
reduce[14][33]=18;
reduce[14][35]=18;
reduce[14][3]=18;
reduce[14][40]=18;
reduce[15][10]=27;
reduce[15][30]=27;
reduce[15][32]=27;
reduce[15][33]=27;
reduce[15][35]=27;
reduce[15][3]=27;
reduce[15][40]=27;
reduce[16][10]=28;
reduce[16][3]=28;
reduce[16][40]=28;
reduce[17][10]=22;
reduce[17][30]=22;
reduce[17][32]=22;
reduce[17][3]=22;
reduce[17][40]=22;
reduce[19][10]=25;
reduce[19][30]=25;
reduce[19][32]=25;
reduce[19][33]=25;
reduce[19][35]=25;
reduce[19][3]=25;
reduce[19][40]=25;
reduce[20][3]=34;
reduce[20][40]=34;
reduce[21][3]=38;
reduce[26][3]=54;
reduce[27][3]=60;
reduce[29][65]=2;
reduce[35][24]=19;
reduce[35][30]=19;
reduce[35][32]=19;
reduce[35][33]=19;
reduce[35][35]=19;
reduce[36][24]=17;
reduce[36][30]=17;
reduce[36][32]=17;
reduce[36][33]=17;
reduce[36][35]=17;
reduce[38][24]=18;
reduce[38][30]=18;
reduce[38][32]=18;
reduce[38][33]=18;
reduce[38][35]=18;
reduce[39][24]=27;
reduce[39][30]=27;
reduce[39][32]=27;
reduce[39][33]=27;
reduce[39][35]=27;
reduce[41][24]=22;
reduce[41][30]=22;
reduce[41][32]=22;
reduce[42][24]=25;
reduce[42][30]=25;
reduce[42][32]=25;
reduce[42][33]=25;
reduce[42][35]=25;
reduce[47][3]=33;
reduce[47][40]=33;
reduce[48][10]=17;
reduce[48][3]=17;
reduce[48][40]=17;
reduce[48][30]=17;
reduce[48][32]=17;
reduce[48][33]=17;
reduce[48][35]=17;
reduce[49][3]=35;
reduce[49][40]=35;
reduce[53][3]=33;
reduce[53][25]=33;
reduce[54][48]=19;
reduce[54][49]=19;
reduce[54][50]=19;
reduce[54][51]=19;
reduce[54][52]=19;
reduce[54][53]=19;
reduce[54][30]=19;
reduce[54][32]=19;
reduce[54][33]=19;
reduce[54][35]=19;
reduce[54][10]=19;
reduce[54][3]=19;
reduce[54][25]=19;
reduce[55][48]=17;
reduce[55][49]=17;
reduce[55][50]=17;
reduce[55][51]=17;
reduce[55][52]=17;
reduce[55][53]=17;
reduce[55][30]=17;
reduce[55][32]=17;
reduce[55][33]=17;
reduce[55][35]=17;
reduce[55][10]=17;
reduce[55][3]=17;
reduce[55][25]=17;
reduce[57][48]=18;
reduce[57][49]=18;
reduce[57][50]=18;
reduce[57][51]=18;
reduce[57][52]=18;
reduce[57][53]=18;
reduce[57][30]=18;
reduce[57][32]=18;
reduce[57][33]=18;
reduce[57][35]=18;
reduce[57][10]=18;
reduce[57][3]=18;
reduce[57][25]=18;
reduce[58][48]=27;
reduce[58][49]=27;
reduce[58][50]=27;
reduce[58][51]=27;
reduce[58][52]=27;
reduce[58][53]=27;
reduce[58][30]=27;
reduce[58][32]=27;
reduce[58][33]=27;
reduce[58][35]=27;
reduce[58][10]=27;
reduce[58][3]=27;
reduce[58][25]=27;
reduce[59][10]=28;
reduce[59][3]=28;
reduce[59][25]=28;
reduce[60][48]=22;
reduce[60][49]=22;
reduce[60][50]=22;
reduce[60][51]=22;
reduce[60][52]=22;
reduce[60][53]=22;
reduce[60][30]=22;
reduce[60][32]=22;
reduce[60][10]=22;
reduce[60][3]=22;
reduce[60][25]=22;
reduce[62][48]=25;
reduce[62][49]=25;
reduce[62][50]=25;
reduce[62][51]=25;
reduce[62][52]=25;
reduce[62][53]=25;
reduce[62][30]=25;
reduce[62][32]=25;
reduce[62][33]=25;
reduce[62][35]=25;
reduce[62][10]=25;
reduce[62][3]=25;
reduce[62][25]=25;
reduce[63][3]=34;
reduce[63][25]=34;
reduce[64][3]=46;
reduce[64][25]=46;
reduce[67][3]=42;
reduce[68][3]=44;
reduce[68][25]=44;
reduce[70][3]=47;
reduce[70][25]=47;
reduce[72][43]=19;
reduce[72][30]=19;
reduce[72][32]=19;
reduce[72][33]=19;
reduce[72][35]=19;
reduce[73][43]=17;
reduce[73][30]=17;
reduce[73][32]=17;
reduce[73][33]=17;
reduce[73][35]=17;
reduce[75][43]=18;
reduce[75][30]=18;
reduce[75][32]=18;
reduce[75][33]=18;
reduce[75][35]=18;
reduce[76][43]=27;
reduce[76][30]=27;
reduce[76][32]=27;
reduce[76][33]=27;
reduce[76][35]=27;
reduce[77][43]=28;
reduce[78][43]=22;
reduce[78][30]=22;
reduce[78][32]=22;
reduce[79][43]=25;
reduce[79][30]=25;
reduce[79][32]=25;
reduce[79][33]=25;
reduce[79][35]=25;
reduce[85][65]=1;
reduce[86][3]=32;
reduce[86][40]=32;
reduce[88][3]=19;
reduce[88][40]=19;
reduce[88][30]=19;
reduce[88][32]=19;
reduce[88][33]=19;
reduce[88][35]=19;
reduce[89][3]=17;
reduce[89][40]=17;
reduce[89][30]=17;
reduce[89][32]=17;
reduce[89][33]=17;
reduce[89][35]=17;
reduce[91][3]=18;
reduce[91][40]=18;
reduce[91][30]=18;
reduce[91][32]=18;
reduce[91][33]=18;
reduce[91][35]=18;
reduce[92][3]=27;
reduce[92][40]=27;
reduce[92][30]=27;
reduce[92][32]=27;
reduce[92][33]=27;
reduce[92][35]=27;
reduce[93][3]=28;
reduce[93][40]=28;
reduce[94][3]=22;
reduce[94][40]=22;
reduce[94][30]=22;
reduce[94][32]=22;
reduce[95][3]=25;
reduce[95][40]=25;
reduce[95][30]=25;
reduce[95][32]=25;
reduce[95][33]=25;
reduce[95][35]=25;
reduce[97][3]=11;
reduce[97][18]=13;
reduce[97][25]=13;
reduce[98][17]=14;
reduce[98][25]=14;
reduce[99][24]=31;
reduce[99][25]=31;
reduce[101][24]=19;
reduce[101][25]=19;
reduce[101][30]=19;
reduce[101][32]=19;
reduce[101][33]=19;
reduce[101][35]=19;
reduce[102][24]=17;
reduce[102][25]=17;
reduce[102][30]=17;
reduce[102][32]=17;
reduce[102][33]=17;
reduce[102][35]=17;
reduce[104][24]=18;
reduce[104][25]=18;
reduce[104][30]=18;
reduce[104][32]=18;
reduce[104][33]=18;
reduce[104][35]=18;
reduce[105][24]=27;
reduce[105][25]=27;
reduce[105][30]=27;
reduce[105][32]=27;
reduce[105][33]=27;
reduce[105][35]=27;
reduce[106][24]=28;
reduce[106][25]=28;
reduce[107][24]=22;
reduce[107][25]=22;
reduce[107][30]=22;
reduce[107][32]=22;
reduce[108][24]=25;
reduce[108][25]=25;
reduce[108][30]=25;
reduce[108][32]=25;
reduce[108][33]=25;
reduce[108][35]=25;
reduce[111][10]=26;
reduce[111][30]=26;
reduce[111][32]=26;
reduce[111][33]=26;
reduce[111][35]=26;
reduce[111][3]=26;
reduce[111][40]=26;
reduce[116][10]=17;
reduce[116][30]=17;
reduce[116][32]=17;
reduce[116][3]=17;
reduce[116][40]=17;
reduce[116][33]=17;
reduce[116][35]=17;
reduce[117][10]=20;
reduce[117][30]=20;
reduce[117][32]=20;
reduce[117][3]=20;
reduce[117][40]=20;
reduce[118][10]=21;
reduce[118][30]=21;
reduce[118][32]=21;
reduce[118][3]=21;
reduce[118][40]=21;
reduce[119][10]=23;
reduce[119][30]=23;
reduce[119][32]=23;
reduce[119][33]=23;
reduce[119][35]=23;
reduce[119][3]=23;
reduce[119][40]=23;
reduce[120][10]=24;
reduce[120][30]=24;
reduce[120][32]=24;
reduce[120][33]=24;
reduce[120][35]=24;
reduce[120][3]=24;
reduce[120][40]=24;
reduce[122][3]=39;
reduce[123][24]=33;
reduce[124][10]=19;
reduce[124][24]=19;
reduce[124][30]=19;
reduce[124][32]=19;
reduce[124][33]=19;
reduce[124][35]=19;
reduce[125][10]=17;
reduce[125][24]=17;
reduce[125][30]=17;
reduce[125][32]=17;
reduce[125][33]=17;
reduce[125][35]=17;
reduce[127][10]=18;
reduce[127][24]=18;
reduce[127][30]=18;
reduce[127][32]=18;
reduce[127][33]=18;
reduce[127][35]=18;
reduce[128][10]=27;
reduce[128][24]=27;
reduce[128][30]=27;
reduce[128][32]=27;
reduce[128][33]=27;
reduce[128][35]=27;
reduce[129][10]=28;
reduce[129][24]=28;
reduce[130][10]=22;
reduce[130][24]=22;
reduce[130][30]=22;
reduce[130][32]=22;
reduce[132][10]=25;
reduce[132][24]=25;
reduce[132][30]=25;
reduce[132][32]=25;
reduce[132][33]=25;
reduce[132][35]=25;
reduce[133][24]=34;
reduce[151][10]=19;
reduce[151][3]=19;
reduce[151][25]=19;
reduce[151][30]=19;
reduce[151][32]=19;
reduce[151][33]=19;
reduce[151][35]=19;
reduce[152][10]=17;
reduce[152][3]=17;
reduce[152][25]=17;
reduce[152][30]=17;
reduce[152][32]=17;
reduce[152][33]=17;
reduce[152][35]=17;
reduce[154][10]=18;
reduce[154][3]=18;
reduce[154][25]=18;
reduce[154][30]=18;
reduce[154][32]=18;
reduce[154][33]=18;
reduce[154][35]=18;
reduce[155][10]=27;
reduce[155][3]=27;
reduce[155][25]=27;
reduce[155][30]=27;
reduce[155][32]=27;
reduce[155][33]=27;
reduce[155][35]=27;
reduce[156][10]=28;
reduce[156][3]=28;
reduce[156][25]=28;
reduce[157][10]=22;
reduce[157][3]=22;
reduce[157][25]=22;
reduce[157][30]=22;
reduce[157][32]=22;
reduce[158][10]=25;
reduce[158][3]=25;
reduce[158][25]=25;
reduce[158][30]=25;
reduce[158][32]=25;
reduce[158][33]=25;
reduce[158][35]=25;
reduce[159][3]=35;
reduce[159][25]=35;
reduce[163][3]=45;
reduce[163][25]=45;
reduce[171][3]=55;
reduce[172][3]=61;
reduce[173][13]=33;
reduce[173][25]=33;
reduce[174][10]=19;
reduce[174][13]=19;
reduce[174][30]=19;
reduce[174][32]=19;
reduce[174][33]=19;
reduce[174][35]=19;
reduce[174][25]=19;
reduce[175][10]=17;
reduce[175][13]=17;
reduce[175][30]=17;
reduce[175][32]=17;
reduce[175][33]=17;
reduce[175][35]=17;
reduce[175][25]=17;
reduce[177][10]=18;
reduce[177][13]=18;
reduce[177][30]=18;
reduce[177][32]=18;
reduce[177][33]=18;
reduce[177][35]=18;
reduce[177][25]=18;
reduce[178][10]=27;
reduce[178][13]=27;
reduce[178][30]=27;
reduce[178][32]=27;
reduce[178][33]=27;
reduce[178][35]=27;
reduce[178][25]=27;
reduce[179][10]=28;
reduce[179][13]=28;
reduce[179][25]=28;
reduce[180][10]=22;
reduce[180][13]=22;
reduce[180][30]=22;
reduce[180][32]=22;
reduce[180][25]=22;
reduce[181][10]=25;
reduce[181][13]=25;
reduce[181][30]=25;
reduce[181][32]=25;
reduce[181][33]=25;
reduce[181][35]=25;
reduce[181][25]=25;
reduce[182][13]=70;
reduce[182][25]=70;
reduce[184][13]=65;
reduce[184][25]=65;
reduce[186][43]=33;
reduce[186][25]=33;
reduce[187][10]=19;
reduce[187][43]=19;
reduce[187][30]=19;
reduce[187][32]=19;
reduce[187][33]=19;
reduce[187][35]=19;
reduce[187][25]=19;
reduce[188][10]=17;
reduce[188][43]=17;
reduce[188][30]=17;
reduce[188][32]=17;
reduce[188][33]=17;
reduce[188][35]=17;
reduce[188][25]=17;
reduce[190][10]=18;
reduce[190][43]=18;
reduce[190][30]=18;
reduce[190][32]=18;
reduce[190][33]=18;
reduce[190][35]=18;
reduce[190][25]=18;
reduce[191][10]=27;
reduce[191][43]=27;
reduce[191][30]=27;
reduce[191][32]=27;
reduce[191][33]=27;
reduce[191][35]=27;
reduce[191][25]=27;
reduce[192][10]=28;
reduce[192][43]=28;
reduce[192][25]=28;
reduce[193][10]=22;
reduce[193][43]=22;
reduce[193][30]=22;
reduce[193][32]=22;
reduce[193][25]=22;
reduce[194][10]=25;
reduce[194][43]=25;
reduce[194][30]=25;
reduce[194][32]=25;
reduce[194][33]=25;
reduce[194][35]=25;
reduce[194][25]=25;
reduce[195][43]=70;
reduce[195][25]=70;
reduce[197][43]=65;
reduce[197][25]=65;
reduce[199][53]=31;
reduce[199][25]=31;
reduce[201][53]=19;
reduce[201][25]=19;
reduce[201][30]=19;
reduce[201][32]=19;
reduce[201][33]=19;
reduce[201][35]=19;
reduce[202][53]=17;
reduce[202][25]=17;
reduce[202][30]=17;
reduce[202][32]=17;
reduce[202][33]=17;
reduce[202][35]=17;
reduce[204][53]=18;
reduce[204][25]=18;
reduce[204][30]=18;
reduce[204][32]=18;
reduce[204][33]=18;
reduce[204][35]=18;
reduce[205][53]=27;
reduce[205][25]=27;
reduce[205][30]=27;
reduce[205][32]=27;
reduce[205][33]=27;
reduce[205][35]=27;
reduce[206][53]=28;
reduce[206][25]=28;
reduce[207][53]=22;
reduce[207][25]=22;
reduce[207][30]=22;
reduce[207][32]=22;
reduce[208][53]=25;
reduce[208][25]=25;
reduce[208][30]=25;
reduce[208][32]=25;
reduce[208][33]=25;
reduce[208][35]=25;
reduce[209][13]=31;
reduce[209][25]=31;
reduce[211][13]=19;
reduce[211][25]=19;
reduce[211][30]=19;
reduce[211][32]=19;
reduce[211][33]=19;
reduce[211][35]=19;
reduce[212][13]=17;
reduce[212][25]=17;
reduce[212][30]=17;
reduce[212][32]=17;
reduce[212][33]=17;
reduce[212][35]=17;
reduce[214][13]=18;
reduce[214][25]=18;
reduce[214][30]=18;
reduce[214][32]=18;
reduce[214][33]=18;
reduce[214][35]=18;
reduce[215][13]=27;
reduce[215][25]=27;
reduce[215][30]=27;
reduce[215][32]=27;
reduce[215][33]=27;
reduce[215][35]=27;
reduce[216][13]=28;
reduce[216][25]=28;
reduce[217][13]=22;
reduce[217][25]=22;
reduce[217][30]=22;
reduce[217][32]=22;
reduce[218][13]=25;
reduce[218][25]=25;
reduce[218][30]=25;
reduce[218][32]=25;
reduce[218][33]=25;
reduce[218][35]=25;
reduce[227][10]=29;
reduce[227][3]=29;
reduce[227][40]=29;
reduce[236][24]=26;
reduce[236][30]=26;
reduce[236][32]=26;
reduce[236][33]=26;
reduce[236][35]=26;
reduce[237][24]=20;
reduce[237][30]=20;
reduce[237][32]=20;
reduce[238][24]=21;
reduce[238][30]=21;
reduce[238][32]=21;
reduce[239][24]=23;
reduce[239][30]=23;
reduce[239][32]=23;
reduce[239][33]=23;
reduce[239][35]=23;
reduce[240][24]=24;
reduce[240][30]=24;
reduce[240][32]=24;
reduce[240][33]=24;
reduce[240][35]=24;
reduce[248][24]=35;
reduce[249][3]=36;
reduce[249][40]=36;
reduce[252][3]=37;
reduce[252][40]=37;
reduce[253][3]=32;
reduce[253][25]=32;
reduce[254][3]=19;
reduce[254][25]=19;
reduce[254][30]=19;
reduce[254][32]=19;
reduce[254][33]=19;
reduce[254][35]=19;
reduce[255][3]=17;
reduce[255][25]=17;
reduce[255][30]=17;
reduce[255][32]=17;
reduce[255][33]=17;
reduce[255][35]=17;
reduce[257][3]=18;
reduce[257][25]=18;
reduce[257][30]=18;
reduce[257][32]=18;
reduce[257][33]=18;
reduce[257][35]=18;
reduce[258][3]=27;
reduce[258][25]=27;
reduce[258][30]=27;
reduce[258][32]=27;
reduce[258][33]=27;
reduce[258][35]=27;
reduce[259][3]=28;
reduce[259][25]=28;
reduce[260][3]=22;
reduce[260][25]=22;
reduce[260][30]=22;
reduce[260][32]=22;
reduce[261][3]=25;
reduce[261][25]=25;
reduce[261][30]=25;
reduce[261][32]=25;
reduce[261][33]=25;
reduce[261][35]=25;
reduce[263][48]=26;
reduce[263][49]=26;
reduce[263][50]=26;
reduce[263][51]=26;
reduce[263][52]=26;
reduce[263][53]=26;
reduce[263][30]=26;
reduce[263][32]=26;
reduce[263][33]=26;
reduce[263][35]=26;
reduce[263][10]=26;
reduce[263][3]=26;
reduce[263][25]=26;
reduce[264][48]=17;
reduce[264][49]=17;
reduce[264][50]=17;
reduce[264][51]=17;
reduce[264][52]=17;
reduce[264][53]=17;
reduce[264][30]=17;
reduce[264][32]=17;
reduce[264][10]=17;
reduce[264][3]=17;
reduce[264][25]=17;
reduce[264][33]=17;
reduce[264][35]=17;
reduce[265][48]=20;
reduce[265][49]=20;
reduce[265][50]=20;
reduce[265][51]=20;
reduce[265][52]=20;
reduce[265][53]=20;
reduce[265][30]=20;
reduce[265][32]=20;
reduce[265][10]=20;
reduce[265][3]=20;
reduce[265][25]=20;
reduce[266][48]=21;
reduce[266][49]=21;
reduce[266][50]=21;
reduce[266][51]=21;
reduce[266][52]=21;
reduce[266][53]=21;
reduce[266][30]=21;
reduce[266][32]=21;
reduce[266][10]=21;
reduce[266][3]=21;
reduce[266][25]=21;
reduce[267][3]=17;
reduce[267][25]=17;
reduce[267][30]=17;
reduce[267][32]=17;
reduce[267][33]=17;
reduce[267][35]=17;
reduce[268][3]=48;
reduce[268][25]=48;
reduce[269][3]=49;
reduce[269][25]=49;
reduce[270][3]=50;
reduce[270][25]=50;
reduce[271][3]=51;
reduce[271][25]=51;
reduce[272][3]=52;
reduce[272][25]=52;
reduce[273][3]=53;
reduce[273][25]=53;
reduce[274][48]=23;
reduce[274][49]=23;
reduce[274][50]=23;
reduce[274][51]=23;
reduce[274][52]=23;
reduce[274][53]=23;
reduce[274][30]=23;
reduce[274][32]=23;
reduce[274][33]=23;
reduce[274][35]=23;
reduce[274][10]=23;
reduce[274][3]=23;
reduce[274][25]=23;
reduce[275][48]=24;
reduce[275][49]=24;
reduce[275][50]=24;
reduce[275][51]=24;
reduce[275][52]=24;
reduce[275][53]=24;
reduce[275][30]=24;
reduce[275][32]=24;
reduce[275][33]=24;
reduce[275][35]=24;
reduce[275][10]=24;
reduce[275][3]=24;
reduce[275][25]=24;
reduce[283][3]=43;
reduce[283][25]=43;
reduce[284][44]=33;
reduce[285][10]=19;
reduce[285][44]=19;
reduce[285][30]=19;
reduce[285][32]=19;
reduce[285][33]=19;
reduce[285][35]=19;
reduce[286][10]=17;
reduce[286][44]=17;
reduce[286][30]=17;
reduce[286][32]=17;
reduce[286][33]=17;
reduce[286][35]=17;
reduce[288][10]=18;
reduce[288][44]=18;
reduce[288][30]=18;
reduce[288][32]=18;
reduce[288][33]=18;
reduce[288][35]=18;
reduce[289][10]=27;
reduce[289][44]=27;
reduce[289][30]=27;
reduce[289][32]=27;
reduce[289][33]=27;
reduce[289][35]=27;
reduce[290][10]=28;
reduce[290][44]=28;
reduce[291][10]=22;
reduce[291][44]=22;
reduce[291][30]=22;
reduce[291][32]=22;
reduce[293][10]=25;
reduce[293][44]=25;
reduce[293][30]=25;
reduce[293][32]=25;
reduce[293][33]=25;
reduce[293][35]=25;
reduce[294][44]=34;
reduce[301][43]=26;
reduce[301][30]=26;
reduce[301][32]=26;
reduce[301][33]=26;
reduce[301][35]=26;
reduce[302][43]=17;
reduce[302][30]=17;
reduce[302][32]=17;
reduce[302][33]=17;
reduce[302][35]=17;
reduce[303][43]=20;
reduce[303][30]=20;
reduce[303][32]=20;
reduce[304][43]=21;
reduce[304][30]=21;
reduce[304][32]=21;
reduce[305][43]=23;
reduce[305][30]=23;
reduce[305][32]=23;
reduce[305][33]=23;
reduce[305][35]=23;
reduce[306][43]=24;
reduce[306][30]=24;
reduce[306][32]=24;
reduce[306][33]=24;
reduce[306][35]=24;
reduce[309][62]=33;
reduce[309][63]=33;
reduce[310][24]=19;
reduce[310][30]=19;
reduce[310][32]=19;

reduce[310][33]=19;
reduce[310][35]=19;
reduce[310][10]=19;
reduce[310][62]=19;
reduce[310][63]=19;
reduce[311][24]=17;
reduce[311][30]=17;
reduce[311][32]=17;
reduce[311][33]=17;
reduce[311][35]=17;
reduce[311][10]=17;
reduce[311][62]=17;
reduce[311][63]=17;
reduce[313][24]=18;
reduce[313][30]=18;
reduce[313][32]=18;
reduce[313][33]=18;
reduce[313][35]=18;
reduce[313][10]=18;
reduce[313][62]=18;
reduce[313][63]=18;
reduce[314][24]=27;
reduce[314][30]=27;
reduce[314][32]=27;
reduce[314][33]=27;
reduce[314][35]=27;
reduce[314][10]=27;
reduce[314][62]=27;
reduce[314][63]=27;
reduce[315][10]=28;
reduce[315][62]=28;
reduce[315][63]=28;
reduce[316][24]=22;
reduce[316][30]=22;
reduce[316][32]=22;
reduce[316][10]=22;
reduce[316][62]=22;
reduce[316][63]=22;
reduce[317][24]=25;
reduce[317][30]=25;
reduce[317][32]=25;
reduce[317][33]=25;
reduce[317][35]=25;
reduce[317][10]=25;
reduce[317][62]=25;
reduce[317][63]=25;
reduce[318][62]=70;
reduce[318][63]=70;
reduce[325][3]=62;
reduce[325][57]=62;
reduce[327][13]=69;
reduce[327][25]=69;
reduce[330][10]=28;
reduce[330][62]=28;
reduce[330][63]=28;
reduce[337][3]=63;
reduce[337][57]=63;
reduce[338][43]=69;
reduce[338][25]=69;
reduce[340][3]=64;
reduce[340][57]=64;
reduce[347][3]=8;
reduce[357][3]=26;
reduce[357][40]=26;
reduce[357][30]=26;
reduce[357][32]=26;
reduce[357][33]=26;
reduce[357][35]=26;
reduce[358][3]=17;
reduce[358][40]=17;
reduce[358][30]=17;
reduce[358][32]=17;
reduce[358][33]=17;
reduce[358][35]=17;
reduce[359][3]=20;
reduce[359][40]=20;
reduce[359][30]=20;
reduce[359][32]=20;
reduce[360][3]=21;
reduce[360][40]=21;
reduce[360][30]=21;
reduce[360][32]=21;
reduce[361][3]=23;
reduce[361][40]=23;
reduce[361][30]=23;
reduce[361][32]=23;
reduce[361][33]=23;
reduce[361][35]=23;
reduce[362][3]=24;
reduce[362][40]=24;
reduce[362][30]=24;
reduce[362][32]=24;
reduce[362][33]=24;
reduce[362][35]=24;
reduce[363][3]=10;
reduce[364][18]=14;
reduce[364][25]=14;
reduce[365][24]=30;
reduce[365][25]=30;
reduce[367][24]=26;
reduce[367][25]=26;
reduce[367][30]=26;
reduce[367][32]=26;
reduce[367][33]=26;
reduce[367][35]=26;
reduce[368][24]=17;
reduce[368][25]=17;
reduce[368][30]=17;
reduce[368][32]=17;
reduce[368][33]=17;
reduce[368][35]=17;
reduce[369][24]=20;
reduce[369][25]=20;
reduce[369][30]=20;
reduce[369][32]=20;
reduce[370][24]=21;
reduce[370][25]=21;
reduce[370][30]=21;
reduce[370][32]=21;
reduce[371][24]=23;
reduce[371][25]=23;
reduce[371][30]=23;
reduce[371][32]=23;
reduce[371][33]=23;
reduce[371][35]=23;
reduce[372][24]=24;
reduce[372][25]=24;
reduce[372][30]=24;
reduce[372][32]=24;
reduce[372][33]=24;
reduce[372][35]=24;
reduce[374][24]=15;
reduce[374][27]=15;
reduce[375][24]=32;
reduce[376][24]=17;
reduce[376][30]=17;
reduce[376][32]=17;
reduce[376][33]=17;
reduce[376][35]=17;
reduce[377][24]=28;
reduce[379][10]=26;
reduce[379][24]=26;
reduce[379][30]=26;
reduce[379][32]=26;
reduce[379][33]=26;
reduce[379][35]=26;
reduce[380][10]=17;
reduce[380][24]=17;
reduce[380][30]=17;
reduce[380][32]=17;
reduce[380][33]=17;
reduce[380][35]=17;
reduce[381][10]=20;
reduce[381][24]=20;
reduce[381][30]=20;
reduce[381][32]=20;
reduce[382][10]=21;
reduce[382][24]=21;
reduce[382][30]=21;
reduce[382][32]=21;
reduce[383][10]=23;
reduce[383][24]=23;
reduce[383][30]=23;
reduce[383][32]=23;
reduce[383][33]=23;
reduce[383][35]=23;
reduce[384][10]=24;
reduce[384][24]=24;
reduce[384][30]=24;
reduce[384][32]=24;
reduce[384][33]=24;
reduce[384][35]=24;
reduce[393][10]=29;
reduce[393][3]=29;
reduce[393][25]=29;
reduce[394][10]=26;
reduce[394][3]=26;
reduce[394][25]=26;
reduce[394][30]=26;
reduce[394][32]=26;
reduce[394][33]=26;
reduce[394][35]=26;
reduce[395][10]=17;
reduce[395][3]=17;
reduce[395][25]=17;
reduce[395][30]=17;
reduce[395][32]=17;
reduce[395][33]=17;
reduce[395][35]=17;
reduce[396][10]=20;
reduce[396][3]=20;
reduce[396][25]=20;
reduce[396][30]=20;
reduce[396][32]=20;
reduce[397][10]=21;
reduce[397][3]=21;
reduce[397][25]=21;
reduce[397][30]=21;
reduce[397][32]=21;
reduce[398][10]=23;
reduce[398][3]=23;
reduce[398][25]=23;
reduce[398][30]=23;
reduce[398][32]=23;
reduce[398][33]=23;
reduce[398][35]=23;
reduce[399][10]=24;
reduce[399][3]=24;
reduce[399][25]=24;
reduce[399][30]=24;
reduce[399][32]=24;
reduce[399][33]=24;
reduce[399][35]=24;
reduce[400][3]=36;
reduce[400][25]=36;
reduce[401][3]=37;
reduce[401][25]=37;
reduce[409][44]=35;
reduce[410][3]=41;
reduce[415][43]=29;
reduce[416][13]=32;
reduce[416][25]=32;
reduce[417][13]=19;
reduce[417][25]=19;
reduce[417][30]=19;
reduce[417][32]=19;
reduce[417][33]=19;
reduce[417][35]=19;
reduce[421][10]=28;
reduce[421][62]=28;
reduce[421][63]=28;
reduce[423][10]=26;
reduce[423][13]=26;
reduce[423][30]=26;
reduce[423][32]=26;
reduce[423][33]=26;
reduce[423][35]=26;
reduce[423][25]=26;
reduce[430][10]=19;
reduce[430][62]=19;
reduce[430][63]=19;
reduce[430][30]=19;
reduce[430][32]=19;
reduce[430][33]=19;
reduce[430][35]=19;
reduce[431][10]=17;
reduce[431][62]=17;
reduce[431][63]=17;
reduce[431][30]=17;
reduce[431][32]=17;
reduce[431][33]=17;
reduce[431][35]=17;
reduce[433][10]=18;
reduce[433][62]=18;
reduce[433][63]=18;
reduce[433][30]=18;
reduce[433][32]=18;
reduce[433][33]=18;
reduce[433][35]=18;
reduce[434][10]=27;
reduce[434][62]=27;
reduce[434][63]=27;
reduce[434][30]=27;
reduce[434][32]=27;
reduce[434][33]=27;
reduce[434][35]=27;
reduce[435][10]=28;
reduce[435][62]=28;
reduce[435][63]=28;
reduce[436][10]=22;
reduce[436][62]=22;
reduce[436][63]=22;
reduce[436][30]=22;
reduce[436][32]=22;
reduce[437][10]=25;
reduce[437][62]=25;
reduce[437][63]=25;
reduce[437][30]=25;
reduce[437][32]=25;
reduce[437][33]=25;
reduce[437][35]=25;
reduce[438][62]=69;
reduce[438][63]=69;
reduce[439][10]=17;
reduce[439][13]=17;
reduce[439][30]=17;
reduce[439][32]=17;
reduce[439][25]=17;
reduce[439][33]=17;
reduce[439][35]=17;
reduce[441][10]=20;
reduce[441][13]=20;
reduce[441][30]=20;
reduce[441][32]=20;
reduce[441][25]=20;
reduce[442][10]=21;
reduce[442][13]=21;
reduce[442][30]=21;
reduce[442][32]=21;
reduce[442][25]=21;
reduce[443][10]=23;
reduce[443][13]=23;
reduce[443][30]=23;
reduce[443][32]=23;
reduce[443][33]=23;
reduce[443][35]=23;
reduce[443][25]=23;
reduce[444][10]=24;
reduce[444][13]=24;
reduce[444][30]=24;
reduce[444][32]=24;
reduce[444][33]=24;
reduce[444][35]=24;
reduce[444][25]=24;
reduce[445][13]=66;
reduce[445][25]=66;
reduce[446][43]=32;
reduce[446][25]=32;
reduce[447][43]=19;
reduce[447][25]=19;
reduce[447][30]=19;
reduce[447][32]=19;
reduce[447][33]=19;
reduce[447][35]=19;
reduce[448][43]=17;
reduce[448][25]=17;
reduce[448][30]=17;
reduce[448][32]=17;
reduce[448][33]=17;
reduce[448][35]=17;
reduce[450][43]=18;
reduce[450][25]=18;
reduce[450][30]=18;
reduce[450][32]=18;
reduce[450][33]=18;
reduce[450][35]=18;
reduce[451][43]=27;
reduce[451][25]=27;
reduce[451][30]=27;
reduce[451][32]=27;
reduce[451][33]=27;
reduce[451][35]=27;
reduce[452][43]=28;
reduce[452][25]=28;
reduce[453][43]=22;
reduce[453][25]=22;
reduce[453][30]=22;
reduce[453][32]=22;
reduce[454][43]=25;
reduce[454][25]=25;
reduce[454][30]=25;
reduce[454][32]=25;
reduce[454][33]=25;
reduce[454][35]=25;
reduce[456][10]=26;
reduce[456][43]=26;
reduce[456][30]=26;
reduce[456][32]=26;
reduce[456][33]=26;
reduce[456][35]=26;
reduce[456][25]=26;
reduce[459][10]=17;
reduce[459][43]=17;
reduce[459][30]=17;
reduce[459][32]=17;
reduce[459][25]=17;
reduce[459][33]=17;
reduce[459][35]=17;
reduce[461][10]=20;
reduce[461][43]=20;
reduce[461][30]=20;
reduce[461][32]=20;
reduce[461][25]=20;
reduce[462][10]=21;
reduce[462][43]=21;
reduce[462][30]=21;
reduce[462][32]=21;
reduce[462][25]=21;
reduce[463][10]=23;
reduce[463][43]=23;
reduce[463][30]=23;
reduce[463][32]=23;
reduce[463][33]=23;
reduce[463][35]=23;
reduce[463][25]=23;
reduce[464][10]=24;
reduce[464][43]=24;
reduce[464][30]=24;
reduce[464][32]=24;
reduce[464][33]=24;
reduce[464][35]=24;
reduce[464][25]=24;
reduce[465][43]=66;
reduce[465][25]=66;
reduce[466][53]=30;
reduce[466][25]=30;
reduce[468][53]=26;
reduce[468][25]=26;
reduce[468][30]=26;
reduce[468][32]=26;
reduce[468][33]=26;
reduce[468][35]=26;
reduce[469][53]=17;
reduce[469][25]=17;
reduce[469][30]=17;
reduce[469][32]=17;
reduce[469][33]=17;
reduce[469][35]=17;
reduce[470][53]=20;
reduce[470][25]=20;
reduce[470][30]=20;
reduce[470][32]=20;
reduce[471][53]=21;
reduce[471][25]=21;
reduce[471][30]=21;
reduce[471][32]=21;
reduce[472][53]=23;
reduce[472][25]=23;
reduce[472][30]=23;
reduce[472][32]=23;
reduce[472][33]=23;
reduce[472][35]=23;
reduce[473][53]=24;
reduce[473][25]=24;
reduce[473][30]=24;
reduce[473][32]=24;
reduce[473][33]=24;
reduce[473][35]=24;
reduce[474][13]=30;
reduce[474][25]=30;
reduce[477][13]=26;
reduce[477][25]=26;
reduce[477][30]=26;
reduce[477][32]=26;
reduce[477][33]=26;
reduce[477][35]=26;
reduce[478][13]=17;
reduce[478][25]=17;
reduce[478][30]=17;
reduce[478][32]=17;
reduce[478][33]=17;
reduce[478][35]=17;
reduce[479][13]=20;
reduce[479][25]=20;
reduce[479][30]=20;
reduce[479][32]=20;
reduce[480][13]=21;
reduce[480][25]=21;
reduce[480][30]=21;
reduce[480][32]=21;
reduce[481][13]=23;
reduce[481][25]=23;
reduce[481][30]=23;
reduce[481][32]=23;
reduce[481][33]=23;
reduce[481][35]=23;
reduce[482][13]=24;
reduce[482][25]=24;
reduce[482][30]=24;
reduce[482][32]=24;
reduce[482][33]=24;
reduce[482][35]=24;
reduce[483][3]=29;
reduce[483][40]=29;
reduce[484][24]=29;
reduce[484][25]=29;
reduce[485][3]=12;
reduce[488][10]=29;
reduce[488][24]=29;
reduce[489][24]=36;
reduce[490][24]=37;
reduce[492][3]=26;
reduce[492][25]=26;
reduce[492][30]=26;
reduce[492][32]=26;
reduce[492][33]=26;
reduce[492][35]=26;
reduce[493][3]=20;
reduce[493][25]=20;
reduce[493][30]=20;
reduce[493][32]=20;
reduce[494][3]=21;
reduce[494][25]=21;
reduce[494][30]=21;
reduce[494][32]=21;
reduce[495][3]=23;
reduce[495][25]=23;
reduce[495][30]=23;
reduce[495][32]=23;
reduce[495][33]=23;
reduce[495][35]=23;
reduce[496][3]=24;
reduce[496][25]=24;
reduce[496][30]=24;
reduce[496][32]=24;
reduce[496][33]=24;
reduce[496][35]=24;
reduce[497][44]=32;
reduce[498][44]=19;
reduce[498][30]=19;
reduce[498][32]=19;
reduce[498][33]=19;
reduce[498][35]=19;
reduce[499][44]=17;
reduce[499][30]=17;
reduce[499][32]=17;
reduce[499][33]=17;
reduce[499][35]=17;
reduce[501][44]=18;
reduce[501][30]=18;
reduce[501][32]=18;
reduce[501][33]=18;
reduce[501][35]=18;
reduce[502][44]=27;
reduce[502][30]=27;
reduce[502][32]=27;
reduce[502][33]=27;
reduce[502][35]=27;
reduce[503][44]=28;
reduce[504][44]=22;
reduce[504][30]=22;
reduce[504][32]=22;
reduce[505][44]=25;
reduce[505][30]=25;
reduce[505][32]=25;
reduce[505][33]=25;
reduce[505][35]=25;
reduce[507][10]=26;
reduce[507][44]=26;
reduce[507][30]=26;
reduce[507][32]=26;
reduce[507][33]=26;
reduce[507][35]=26;
reduce[508][10]=17;
reduce[508][44]=17;
reduce[508][30]=17;
reduce[508][32]=17;
reduce[508][33]=17;
reduce[508][35]=17;
reduce[509][10]=20;
reduce[509][44]=20;
reduce[509][30]=20;
reduce[509][32]=20;
reduce[510][10]=21;
reduce[510][44]=21;
reduce[510][30]=21;
reduce[510][32]=21;
reduce[511][10]=23;
reduce[511][44]=23;
reduce[511][30]=23;
reduce[511][32]=23;
reduce[511][33]=23;
reduce[511][35]=23;
reduce[512][10]=24;
reduce[512][44]=24;
reduce[512][30]=24;
reduce[512][32]=24;
reduce[512][33]=24;
reduce[512][35]=24;
reduce[513][3]=40;
reduce[517][17]=19;
reduce[517][24]=19;
reduce[517][30]=19;
reduce[517][32]=19;
reduce[517][33]=19;
reduce[517][35]=19;
reduce[518][17]=17;
reduce[518][24]=17;
reduce[518][30]=17;
reduce[518][32]=17;
reduce[518][33]=17;
reduce[518][35]=17;
reduce[520][17]=18;
reduce[520][24]=18;
reduce[520][30]=18;
reduce[520][32]=18;
reduce[520][33]=18;
reduce[520][35]=18;
reduce[521][17]=27;
reduce[521][24]=27;
reduce[521][30]=27;
reduce[521][32]=27;
reduce[521][33]=27;
reduce[521][35]=27;
reduce[522][17]=28;
reduce[522][24]=28;
reduce[523][17]=22;
reduce[523][24]=22;
reduce[523][30]=22;
reduce[523][32]=22;
reduce[524][17]=25;
reduce[524][24]=25;
reduce[524][30]=25;
reduce[524][32]=25;
reduce[524][33]=25;
reduce[524][35]=25;
reduce[525][57]=33;
reduce[525][24]=33;
reduce[526][10]=19;
reduce[526][57]=19;
reduce[526][24]=19;
reduce[526][30]=19;
reduce[526][32]=19;
reduce[526][33]=19;
reduce[526][35]=19;
reduce[527][10]=17;
reduce[527][57]=17;
reduce[527][24]=17;
reduce[527][30]=17;
reduce[527][32]=17;
reduce[527][33]=17;
reduce[527][35]=17;
reduce[529][10]=18;
reduce[529][57]=18;
reduce[529][24]=18;
reduce[529][30]=18;
reduce[529][32]=18;
reduce[529][33]=18;
reduce[529][35]=18;
reduce[530][10]=27;
reduce[530][57]=27;
reduce[530][24]=27;
reduce[530][30]=27;
reduce[530][32]=27;
reduce[530][33]=27;
reduce[530][35]=27;
reduce[531][10]=28;
reduce[531][57]=28;
reduce[531][24]=28;
reduce[532][10]=22;
reduce[532][57]=22;
reduce[532][24]=22;
reduce[532][30]=22;
reduce[532][32]=22;
reduce[533][10]=25;
reduce[533][57]=25;
reduce[533][24]=25;
reduce[533][30]=25;
reduce[533][32]=25;
reduce[533][33]=25;
reduce[533][35]=25;
reduce[535][10]=29;
reduce[535][13]=29;
reduce[535][25]=29;
reduce[536][62]=32;
reduce[536][63]=32;
reduce[537][62]=19;
reduce[537][63]=19;
reduce[537][30]=19;
reduce[537][32]=19;
reduce[537][33]=19;
reduce[537][35]=19;
reduce[538][62]=17;
reduce[538][63]=17;
reduce[538][30]=17;
reduce[538][32]=17;
reduce[538][33]=17;
reduce[538][35]=17;
reduce[540][62]=18;
reduce[540][63]=18;
reduce[540][30]=18;
reduce[540][32]=18;
reduce[540][33]=18;
reduce[540][35]=18;
reduce[541][62]=27;
reduce[541][63]=27;
reduce[541][30]=27;
reduce[541][32]=27;
reduce[541][33]=27;
reduce[541][35]=27;
reduce[542][62]=28;
reduce[542][63]=28;
reduce[543][62]=22;
reduce[543][63]=22;
reduce[543][30]=22;
reduce[543][32]=22;
reduce[544][62]=25;
reduce[544][63]=25;
reduce[544][30]=25;
reduce[544][32]=25;
reduce[544][33]=25;
reduce[544][35]=25;
reduce[546][24]=26;
reduce[546][30]=26;
reduce[546][32]=26;
reduce[546][33]=26;
reduce[546][35]=26;
reduce[546][10]=26;
reduce[546][62]=26;
reduce[546][63]=26;
reduce[549][24]=17;
reduce[549][30]=17;
reduce[549][32]=17;
reduce[549][10]=17;
reduce[549][62]=17;
reduce[549][63]=17;
reduce[549][33]=17;
reduce[549][35]=17;
reduce[551][24]=20;
reduce[551][30]=20;
reduce[551][32]=20;
reduce[551][10]=20;
reduce[551][62]=20;
reduce[551][63]=20;
reduce[552][24]=21;
reduce[552][30]=21;
reduce[552][32]=21;
reduce[552][10]=21;
reduce[552][62]=21;
reduce[552][63]=21;
reduce[553][24]=23;
reduce[553][30]=23;
reduce[553][32]=23;
reduce[553][33]=23;
reduce[553][35]=23;
reduce[553][10]=23;
reduce[553][62]=23;
reduce[553][63]=23;
reduce[554][24]=24;
reduce[554][30]=24;
reduce[554][32]=24;
reduce[554][33]=24;
reduce[554][35]=24;
reduce[554][10]=24;
reduce[554][62]=24;
reduce[554][63]=24;
reduce[556][24]=70;
reduce[560][10]=28;
reduce[560][62]=28;
reduce[560][63]=28;
reduce[572][10]=29;
reduce[572][43]=29;
reduce[572][25]=29;
reduce[576][53]=29;
reduce[576][25]=29;
reduce[577][3]=9;
reduce[578][13]=29;
reduce[578][25]=29;
reduce[579][24]=16;
reduce[579][27]=16;
reduce[581][3]=29;
reduce[581][25]=29;
reduce[588][10]=29;
reduce[588][44]=29;
reduce[589][44]=36;
reduce[590][44]=37;
reduce[592][3]=57;
reduce[592][40]=57;
reduce[614][10]=29;
reduce[614][62]=29;
reduce[614][63]=29;
reduce[618][10]=28;
reduce[618][62]=28;
reduce[618][63]=28;
reduce[620][13]=67;
reduce[620][25]=67;
reduce[621][24]=69;
reduce[622][13]=68;
reduce[622][25]=68;
reduce[623][10]=26;
reduce[623][62]=26;
reduce[623][63]=26;
reduce[623][30]=26;
reduce[623][32]=26;
reduce[623][33]=26;
reduce[623][35]=26;
reduce[624][10]=17;
reduce[624][62]=17;
reduce[624][63]=17;
reduce[624][30]=17;
reduce[624][32]=17;
reduce[624][33]=17;
reduce[624][35]=17;
reduce[626][10]=20;
reduce[626][62]=20;
reduce[626][63]=20;
reduce[626][30]=20;
reduce[626][32]=20;
reduce[627][10]=21;
reduce[627][62]=21;
reduce[627][63]=21;
reduce[627][30]=21;
reduce[627][32]=21;
reduce[628][10]=23;
reduce[628][62]=23;
reduce[628][63]=23;
reduce[628][30]=23;
reduce[628][32]=23;
reduce[628][33]=23;
reduce[628][35]=23;
reduce[629][10]=24;
reduce[629][62]=24;
reduce[629][63]=24;
reduce[629][30]=24;
reduce[629][32]=24;
reduce[629][33]=24;
reduce[629][35]=24;
reduce[631][43]=26;
reduce[631][25]=26;
reduce[631][30]=26;
reduce[631][32]=26;
reduce[631][33]=26;
reduce[631][35]=26;
reduce[632][43]=17;
reduce[632][25]=17;
reduce[632][30]=17;
reduce[632][32]=17;
reduce[632][33]=17;
reduce[632][35]=17;
reduce[633][43]=20;
reduce[633][25]=20;
reduce[633][30]=20;
reduce[633][32]=20;
reduce[634][43]=21;
reduce[634][25]=21;
reduce[634][30]=21;
reduce[634][32]=21;
reduce[635][43]=23;
reduce[635][25]=23;
reduce[635][30]=23;
reduce[635][32]=23;
reduce[635][33]=23;
reduce[635][35]=23;
reduce[636][43]=24;
reduce[636][25]=24;
reduce[636][30]=24;
reduce[636][32]=24;
reduce[636][33]=24;
reduce[636][35]=24;
reduce[637][43]=67;
reduce[637][25]=67;
reduce[638][43]=68;
reduce[638][25]=68;
reduce[639][24]=29;
reduce[641][44]=26;
reduce[641][30]=26;
reduce[641][32]=26;
reduce[641][33]=26;
reduce[641][35]=26;
reduce[642][44]=17;
reduce[642][30]=17;
reduce[642][32]=17;
reduce[642][33]=17;
reduce[642][35]=17;
reduce[643][44]=20;
reduce[643][30]=20;
reduce[643][32]=20;
reduce[644][44]=21;
reduce[644][30]=21;
reduce[644][32]=21;
reduce[645][44]=23;
reduce[645][30]=23;
reduce[645][32]=23;
reduce[645][33]=23;
reduce[645][35]=23;
reduce[646][44]=24;
reduce[646][30]=24;
reduce[646][32]=24;
reduce[646][33]=24;
reduce[646][35]=24;
reduce[649][17]=26;
reduce[649][24]=26;
reduce[649][30]=26;
reduce[649][32]=26;
reduce[649][33]=26;
reduce[649][35]=26;
reduce[650][17]=17;
reduce[650][24]=17;
reduce[650][30]=17;
reduce[650][32]=17;
reduce[650][33]=17;
reduce[650][35]=17;
reduce[651][17]=20;
reduce[651][24]=20;
reduce[651][30]=20;
reduce[651][32]=20;
reduce[652][17]=21;
reduce[652][24]=21;
reduce[652][30]=21;
reduce[652][32]=21;
reduce[653][17]=23;
reduce[653][24]=23;
reduce[653][30]=23;
reduce[653][32]=23;
reduce[653][33]=23;
reduce[653][35]=23;
reduce[654][17]=24;
reduce[654][24]=24;
reduce[654][30]=24;
reduce[654][32]=24;
reduce[654][33]=24;
reduce[654][35]=24;
reduce[655][57]=32;
reduce[655][24]=32;
reduce[656][57]=19;
reduce[656][24]=19;
reduce[656][30]=19;
reduce[656][32]=19;
reduce[656][33]=19;
reduce[656][35]=19;
reduce[657][57]=17;
reduce[657][24]=17;
reduce[657][30]=17;
reduce[657][32]=17;
reduce[657][33]=17;
reduce[657][35]=17;
reduce[659][57]=18;
reduce[659][24]=18;
reduce[659][30]=18;
reduce[659][32]=18;
reduce[659][33]=18;
reduce[659][35]=18;
reduce[660][57]=27;
reduce[660][24]=27;
reduce[660][30]=27;
reduce[660][32]=27;
reduce[660][33]=27;
reduce[660][35]=27;
reduce[661][57]=28;
reduce[661][24]=28;
reduce[662][57]=22;
reduce[662][24]=22;
reduce[662][30]=22;
reduce[662][32]=22;
reduce[663][57]=25;
reduce[663][24]=25;
reduce[663][30]=25;
reduce[663][32]=25;
reduce[663][33]=25;
reduce[663][35]=25;
reduce[665][10]=26;
reduce[665][57]=26;
reduce[665][24]=26;
reduce[665][30]=26;
reduce[665][32]=26;
reduce[665][33]=26;
reduce[665][35]=26;
reduce[666][10]=17;
reduce[666][57]=17;
reduce[666][24]=17;
reduce[666][30]=17;
reduce[666][32]=17;
reduce[666][33]=17;
reduce[666][35]=17;
reduce[667][10]=20;
reduce[667][57]=20;
reduce[667][24]=20;
reduce[667][30]=20;
reduce[667][32]=20;
reduce[668][10]=21;
reduce[668][57]=21;
reduce[668][24]=21;
reduce[668][30]=21;
reduce[668][32]=21;
reduce[669][10]=23;
reduce[669][57]=23;
reduce[669][24]=23;
reduce[669][30]=23;
reduce[669][32]=23;
reduce[669][33]=23;
reduce[669][35]=23;
reduce[670][10]=24;
reduce[670][57]=24;
reduce[670][24]=24;
reduce[670][30]=24;
reduce[670][32]=24;
reduce[670][33]=24;
reduce[670][35]=24;
reduce[672][24]=33;
reduce[672][25]=33;
reduce[673][48]=19;
reduce[673][49]=19;
reduce[673][50]=19;
reduce[673][51]=19;
reduce[673][52]=19;
reduce[673][53]=19;
reduce[673][30]=19;
reduce[673][32]=19;
reduce[673][33]=19;
reduce[673][35]=19;
reduce[673][10]=19;
reduce[673][24]=19;
reduce[673][25]=19;
reduce[674][48]=17;
reduce[674][49]=17;
reduce[674][50]=17;
reduce[674][51]=17;
reduce[674][52]=17;
reduce[674][53]=17;
reduce[674][30]=17;
reduce[674][32]=17;
reduce[674][33]=17;
reduce[674][35]=17;
reduce[674][10]=17;
reduce[674][24]=17;
reduce[674][25]=17;
reduce[676][48]=18;
reduce[676][49]=18;
reduce[676][50]=18;
reduce[676][51]=18;
reduce[676][52]=18;
reduce[676][53]=18;
reduce[676][30]=18;
reduce[676][32]=18;
reduce[676][33]=18;
reduce[676][35]=18;
reduce[676][10]=18;
reduce[676][24]=18;
reduce[676][25]=18;
reduce[677][48]=27;
reduce[677][49]=27;
reduce[677][50]=27;
reduce[677][51]=27;
reduce[677][52]=27;
reduce[677][53]=27;
reduce[677][30]=27;
reduce[677][32]=27;
reduce[677][33]=27;
reduce[677][35]=27;
reduce[677][10]=27;
reduce[677][24]=27;
reduce[677][25]=27;
reduce[678][10]=28;
reduce[678][24]=28;
reduce[678][25]=28;
reduce[679][48]=22;
reduce[679][49]=22;
reduce[679][50]=22;
reduce[679][51]=22;
reduce[679][52]=22;
reduce[679][53]=22;
reduce[679][30]=22;
reduce[679][32]=22;
reduce[679][10]=22;
reduce[679][24]=22;
reduce[679][25]=22;
reduce[681][48]=25;
reduce[681][49]=25;
reduce[681][50]=25;
reduce[681][51]=25;
reduce[681][52]=25;
reduce[681][53]=25;
reduce[681][30]=25;
reduce[681][32]=25;
reduce[681][33]=25;
reduce[681][35]=25;
reduce[681][10]=25;
reduce[681][24]=25;
reduce[681][25]=25;
reduce[682][24]=34;
reduce[682][25]=34;
reduce[683][24]=46;
reduce[683][25]=46;
reduce[687][24]=44;
reduce[687][25]=44;
reduce[689][24]=47;
reduce[689][25]=47;
reduce[691][62]=26;
reduce[691][63]=26;
reduce[691][30]=26;
reduce[691][32]=26;
reduce[691][33]=26;
reduce[691][35]=26;
reduce[692][62]=17;
reduce[692][63]=17;
reduce[692][30]=17;
reduce[692][32]=17;
reduce[692][33]=17;
reduce[692][35]=17;
reduce[693][62]=20;
reduce[693][63]=20;
reduce[693][30]=20;
reduce[693][32]=20;
reduce[694][62]=21;
reduce[694][63]=21;
reduce[694][30]=21;
reduce[694][32]=21;
reduce[695][62]=23;
reduce[695][63]=23;
reduce[695][30]=23;
reduce[695][32]=23;
reduce[695][33]=23;
reduce[695][35]=23;
reduce[696][62]=24;
reduce[696][63]=24;
reduce[696][30]=24;
reduce[696][32]=24;
reduce[696][33]=24;
reduce[696][35]=24;
reduce[697][62]=67;
reduce[697][63]=67;
reduce[698][62]=68;
reduce[698][63]=68;
reduce[702][43]=29;
reduce[702][25]=29;
reduce[703][44]=29;
reduce[705][17]=29;
reduce[705][24]=29;
reduce[712][10]=29;
reduce[712][57]=29;
reduce[712][24]=29;
reduce[713][3]=19;
reduce[713][30]=19;
reduce[713][32]=19;
reduce[713][33]=19;
reduce[713][35]=19;
reduce[714][3]=17;
reduce[714][30]=17;
reduce[714][32]=17;
reduce[714][33]=17;
reduce[714][35]=17;
reduce[716][3]=18;
reduce[716][30]=18;
reduce[716][32]=18;
reduce[716][33]=18;
reduce[716][35]=18;
reduce[717][3]=27;
reduce[717][30]=27;
reduce[717][32]=27;
reduce[717][33]=27;
reduce[717][35]=27;
reduce[718][3]=59;
reduce[719][3]=22;
reduce[719][30]=22;
reduce[719][32]=22;
reduce[720][3]=25;
reduce[720][30]=25;
reduce[720][32]=25;
reduce[720][33]=25;
reduce[720][35]=25;
reduce[734][10]=19;
reduce[734][24]=19;
reduce[734][25]=19;
reduce[734][30]=19;
reduce[734][32]=19;
reduce[734][33]=19;
reduce[734][35]=19;
reduce[735][10]=17;
reduce[735][24]=17;
reduce[735][25]=17;
reduce[735][30]=17;
reduce[735][32]=17;
reduce[735][33]=17;
reduce[735][35]=17;
reduce[737][10]=18;
reduce[737][24]=18;
reduce[737][25]=18;
reduce[737][30]=18;
reduce[737][32]=18;
reduce[737][33]=18;
reduce[737][35]=18;
reduce[738][10]=27;
reduce[738][24]=27;
reduce[738][25]=27;
reduce[738][30]=27;
reduce[738][32]=27;
reduce[738][33]=27;
reduce[738][35]=27;
reduce[739][10]=28;
reduce[739][24]=28;
reduce[739][25]=28;
reduce[740][10]=22;
reduce[740][24]=22;
reduce[740][25]=22;
reduce[740][30]=22;
reduce[740][32]=22;
reduce[741][10]=25;
reduce[741][24]=25;
reduce[741][25]=25;
reduce[741][30]=25;
reduce[741][32]=25;
reduce[741][33]=25;
reduce[741][35]=25;
reduce[742][24]=35;
reduce[742][25]=35;
reduce[747][24]=45;
reduce[747][25]=45;
reduce[748][62]=29;
reduce[748][63]=29;
reduce[753][57]=26;
reduce[753][24]=26;
reduce[753][30]=26;
reduce[753][32]=26;
reduce[753][33]=26;
reduce[753][35]=26;
reduce[754][57]=17;
reduce[754][24]=17;
reduce[754][30]=17;
reduce[754][32]=17;
reduce[754][33]=17;
reduce[754][35]=17;
reduce[755][57]=20;
reduce[755][24]=20;
reduce[755][30]=20;
reduce[755][32]=20;
reduce[756][57]=21;
reduce[756][24]=21;
reduce[756][30]=21;
reduce[756][32]=21;
reduce[757][57]=23;
reduce[757][24]=23;
reduce[757][30]=23;
reduce[757][32]=23;
reduce[757][33]=23;
reduce[757][35]=23;
reduce[758][57]=24;
reduce[758][24]=24;
reduce[758][30]=24;
reduce[758][32]=24;
reduce[758][33]=24;
reduce[758][35]=24;
reduce[764][24]=32;
reduce[764][25]=32;
reduce[766][48]=26;
reduce[766][49]=26;
reduce[766][50]=26;
reduce[766][51]=26;
reduce[766][52]=26;
reduce[766][53]=26;
reduce[766][30]=26;
reduce[766][32]=26;
reduce[766][33]=26;
reduce[766][35]=26;
reduce[766][10]=26;
reduce[766][24]=26;
reduce[766][25]=26;
reduce[767][48]=17;
reduce[767][49]=17;
reduce[767][50]=17;
reduce[767][51]=17;
reduce[767][52]=17;
reduce[767][53]=17;
reduce[767][30]=17;
reduce[767][32]=17;
reduce[767][10]=17;
reduce[767][24]=17;
reduce[767][25]=17;
reduce[767][33]=17;
reduce[767][35]=17;
reduce[768][48]=20;
reduce[768][49]=20;
reduce[768][50]=20;
reduce[768][51]=20;
reduce[768][52]=20;
reduce[768][53]=20;
reduce[768][30]=20;
reduce[768][32]=20;
reduce[768][10]=20;
reduce[768][24]=20;
reduce[768][25]=20;
reduce[769][48]=21;
reduce[769][49]=21;
reduce[769][50]=21;
reduce[769][51]=21;
reduce[769][52]=21;
reduce[769][53]=21;
reduce[769][30]=21;
reduce[769][32]=21;
reduce[769][10]=21;
reduce[769][24]=21;
reduce[769][25]=21;
reduce[770][24]=48;
reduce[770][25]=48;
reduce[771][24]=49;
reduce[771][25]=49;
reduce[772][24]=50;
reduce[772][25]=50;
reduce[773][24]=51;
reduce[773][25]=51;
reduce[774][24]=52;
reduce[774][25]=52;
reduce[775][24]=53;
reduce[775][25]=53;
reduce[776][48]=23;
reduce[776][49]=23;
reduce[776][50]=23;
reduce[776][51]=23;
reduce[776][52]=23;
reduce[776][53]=23;
reduce[776][30]=23;
reduce[776][32]=23;
reduce[776][33]=23;
reduce[776][35]=23;
reduce[776][10]=23;
reduce[776][24]=23;
reduce[776][25]=23;
reduce[777][48]=24;
reduce[777][49]=24;
reduce[777][50]=24;
reduce[777][51]=24;
reduce[777][52]=24;
reduce[777][53]=24;
reduce[777][30]=24;
reduce[777][32]=24;
reduce[777][33]=24;
reduce[777][35]=24;
reduce[777][10]=24;
reduce[777][24]=24;
reduce[777][25]=24;
reduce[786][24]=43;
reduce[786][25]=43;
reduce[787][24]=67;
reduce[788][24]=68;
reduce[789][13]=33;
reduce[790][10]=19;
reduce[790][13]=19;
reduce[790][30]=19;
reduce[790][32]=19;
reduce[790][33]=19;
reduce[790][35]=19;
reduce[791][10]=17;
reduce[791][13]=17;
reduce[791][30]=17;
reduce[791][32]=17;
reduce[791][33]=17;
reduce[791][35]=17;
reduce[793][10]=18;
reduce[793][13]=18;
reduce[793][30]=18;
reduce[793][32]=18;
reduce[793][33]=18;
reduce[793][35]=18;
reduce[794][10]=27;
reduce[794][13]=27;
reduce[794][30]=27;
reduce[794][32]=27;
reduce[794][33]=27;
reduce[794][35]=27;
reduce[795][10]=28;
reduce[795][13]=28;
reduce[796][10]=22;
reduce[796][13]=22;
reduce[796][30]=22;
reduce[796][32]=22;
reduce[797][10]=25;
reduce[797][13]=25;
reduce[797][30]=25;
reduce[797][32]=25;
reduce[797][33]=25;
reduce[797][35]=25;
reduce[799][57]=29;
reduce[799][24]=29;
reduce[800][3]=26;
reduce[800][30]=26;
reduce[800][32]=26;
reduce[800][33]=26;
reduce[800][35]=26;
reduce[801][3]=20;
reduce[801][30]=20;
reduce[801][32]=20;
reduce[802][3]=21;
reduce[802][30]=21;
reduce[802][32]=21;
reduce[803][3]=23;
reduce[803][30]=23;
reduce[803][32]=23;
reduce[803][33]=23;
reduce[803][35]=23;
reduce[804][3]=24;
reduce[804][30]=24;
reduce[804][32]=24;
reduce[804][33]=24;
reduce[804][35]=24;
reduce[805][10]=29;
reduce[805][24]=29;
reduce[805][25]=29;
reduce[806][10]=26;
reduce[806][24]=26;
reduce[806][25]=26;
reduce[806][30]=26;
reduce[806][32]=26;
reduce[806][33]=26;
reduce[806][35]=26;
reduce[807][10]=17;
reduce[807][24]=17;
reduce[807][25]=17;
reduce[807][30]=17;
reduce[807][32]=17;
reduce[807][33]=17;
reduce[807][35]=17;
reduce[808][10]=20;
reduce[808][24]=20;
reduce[808][25]=20;
reduce[808][30]=20;
reduce[808][32]=20;
reduce[809][10]=21;
reduce[809][24]=21;
reduce[809][25]=21;
reduce[809][30]=21;
reduce[809][32]=21;
reduce[810][10]=23;
reduce[810][24]=23;
reduce[810][25]=23;
reduce[810][30]=23;
reduce[810][32]=23;
reduce[810][33]=23;
reduce[810][35]=23;
reduce[811][10]=24;
reduce[811][24]=24;
reduce[811][25]=24;
reduce[811][30]=24;
reduce[811][32]=24;
reduce[811][33]=24;
reduce[811][35]=24;
reduce[812][24]=36;
reduce[812][25]=36;
reduce[813][24]=37;
reduce[813][25]=37;
reduce[814][3]=58;
reduce[823][13]=32;
reduce[824][13]=19;
reduce[824][30]=19;
reduce[824][32]=19;
reduce[824][33]=19;
reduce[824][35]=19;
reduce[825][13]=17;
reduce[825][30]=17;
reduce[825][32]=17;
reduce[825][33]=17;
reduce[825][35]=17;
reduce[827][13]=18;
reduce[827][30]=18;
reduce[827][32]=18;
reduce[827][33]=18;
reduce[827][35]=18;
reduce[828][13]=27;
reduce[828][30]=27;
reduce[828][32]=27;
reduce[828][33]=27;
reduce[828][35]=27;
reduce[829][13]=28;
reduce[830][13]=22;
reduce[830][30]=22;
reduce[830][32]=22;
reduce[831][13]=25;
reduce[831][30]=25;
reduce[831][32]=25;
reduce[831][33]=25;
reduce[831][35]=25;
reduce[833][10]=26;
reduce[833][13]=26;
reduce[833][30]=26;
reduce[833][32]=26;
reduce[833][33]=26;
reduce[833][35]=26;
reduce[834][10]=17;
reduce[834][13]=17;
reduce[834][30]=17;
reduce[834][32]=17;
reduce[834][33]=17;
reduce[834][35]=17;
reduce[835][10]=20;
reduce[835][13]=20;
reduce[835][30]=20;
reduce[835][32]=20;
reduce[836][10]=21;
reduce[836][13]=21;
reduce[836][30]=21;
reduce[836][32]=21;
reduce[837][10]=23;
reduce[837][13]=23;
reduce[837][30]=23;
reduce[837][32]=23;
reduce[837][33]=23;
reduce[837][35]=23;
reduce[838][10]=24;
reduce[838][13]=24;
reduce[838][30]=24;
reduce[838][32]=24;
reduce[838][33]=24;
reduce[838][35]=24;
reduce[839][3]=56;
reduce[839][40]=56;
reduce[846][10]=29;
reduce[846][13]=29;
reduce[848][13]=26;
reduce[848][30]=26;
reduce[848][32]=26;
reduce[848][33]=26;
reduce[848][35]=26;
reduce[849][13]=17;
reduce[849][30]=17;
reduce[849][32]=17;
reduce[849][33]=17;
reduce[849][35]=17;
reduce[850][13]=20;
reduce[850][30]=20;
reduce[850][32]=20;
reduce[851][13]=21;
reduce[851][30]=21;
reduce[851][32]=21;
reduce[852][13]=23;
reduce[852][30]=23;
reduce[852][32]=23;
reduce[852][33]=23;
reduce[852][35]=23;
reduce[853][13]=24;
reduce[853][30]=24;
reduce[853][32]=24;
reduce[853][33]=24;
reduce[853][35]=24;
reduce[854][13]=29;
igr[1][0]=1;igr[1][1]=3;
igr[2][0]=1;igr[2][1]=2;
igr[3][0]=2;igr[3][1]=1;
igr[4][0]=2;igr[4][1]=1;
igr[5][0]=2;igr[5][1]=1;
igr[6][0]=2;igr[6][1]=1;
igr[7][0]=2;igr[7][1]=1;
igr[8][0]=4;igr[8][1]=5;
igr[9][0]=4;igr[9][1]=7;
igr[10][0]=4;igr[10][1]=5;
igr[11][0]=4;igr[11][1]=3;
igr[12][0]=4;igr[12][1]=6;
igr[13][0]=16;igr[13][1]=1;
igr[14][0]=16;igr[14][1]=3;
igr[15][0]=23;igr[15][1]=1;
igr[16][0]=23;igr[16][1]=3;
igr[17][0]=28;igr[17][1]=1;
igr[18][0]=28;igr[18][1]=1;
igr[19][0]=28;igr[19][1]=1;
igr[20][0]=29;igr[20][1]=3;
igr[21][0]=29;igr[21][1]=3;
igr[22][0]=29;igr[22][1]=1;
igr[23][0]=31;igr[23][1]=3;
igr[24][0]=31;igr[24][1]=3;
igr[25][0]=31;igr[25][1]=1;
igr[26][0]=34;igr[26][1]=3;
igr[27][0]=34;igr[27][1]=1;
igr[28][0]=9;igr[28][1]=1;
igr[29][0]=9;igr[29][1]=4;
igr[30][0]=12;igr[30][1]=3;
igr[31][0]=12;igr[31][1]=1;
igr[32][0]=36;igr[32][1]=3;
igr[33][0]=36;igr[33][1]=1;
igr[34][0]=37;igr[34][1]=1;
igr[35][0]=37;igr[35][1]=2;
igr[36][0]=37;igr[36][1]=4;
igr[37][0]=37;igr[37][1]=4;
igr[38][0]=5;igr[38][1]=1;
igr[39][0]=5;igr[39][1]=3;
igr[40][0]=5;igr[40][1]=6;
igr[41][0]=5;igr[41][1]=5;
igr[42][0]=5;igr[42][1]=2;
igr[43][0]=41;igr[43][1]=3;
igr[44][0]=41;igr[44][1]=1;
igr[45][0]=45;igr[45][1]=2;
igr[46][0]=45;igr[46][1]=1;
igr[47][0]=45;igr[47][1]=1;
igr[48][0]=47;igr[48][1]=3;
igr[49][0]=47;igr[49][1]=3;
igr[50][0]=47;igr[50][1]=3;
igr[51][0]=47;igr[51][1]=3;
igr[52][0]=47;igr[52][1]=3;
igr[53][0]=47;igr[53][1]=3;
igr[54][0]=6;igr[54][1]=1;
igr[55][0]=6;igr[55][1]=3;
igr[56][0]=54;igr[56][1]=13;
igr[57][0]=54;igr[57][1]=7;
igr[58][0]=7;igr[58][1]=11;
igr[59][0]=7;igr[59][1]=9;
igr[60][0]=8;igr[60][1]=1;
igr[61][0]=8;igr[61][1]=3;
igr[62][0]=58;igr[62][1]=4;
igr[63][0]=58;igr[63][1]=4;
igr[64][0]=58;igr[64][1]=4;
igr[65][0]=60;igr[65][1]=1;
igr[66][0]=60;igr[66][1]=3;
igr[67][0]=61;igr[67][1]=5;
igr[68][0]=61;igr[68][1]=5;
igr[69][0]=61;igr[69][1]=2;
igr[70][0]=61;igr[70][1]=1;
}

CParse::~CParse()
{
	//Nothing be done
	//int i;
	//cout<<"Parse descounstruct"<<endl;
	/*
	for(i=0;i<dfptbl;i++){
		delete [] reduce[i];
		delete [] shift[i];
	} 
	delete [] reduce;
	delete [] shift;
	
	for(i=0;i<dfgra;i++){
		delete [] igr[i];
	}
	delete [] igr; */
} 

void CParse::ErrorReport()
{
	int i;	
	for(i=10;i>0;i--){
		if(readPos-i>=0) cout<<memblock[readPos-i];
	}
	cout<<endl<<"Parsing error at this position"<<endl;
	for(i=1;i<20;i++){
		if(readPos+i<memSize) cout<<memblock[readPos+i];
		
	}
	cout<<endl;
}

//Read Files and Get the next token
//Return the token and set current token type
string CParse::GetNextToken()
{
	string sname="";
	//Ignoring comments and spaces and other unuseful characters
	while(readPos<=memSize){
		if(memblock[readPos]=='%'){
			readPos++;
			while(memblock[readPos]!='\n' && readPos<memSize){
				readPos++;
			}
		}
		if(!isprint(memblock[readPos]) || memblock[readPos]==' ') readPos++;
		else break;
	}
	//Indentifier and variable
	if(isalpha(memblock[readPos])){
		do{
			sname.insert(sname.size(),1,memblock[readPos]);
			readPos++;
		}while(isdigit(memblock[readPos]) || isalpha(memblock[readPos]) || memblock[readPos]=='_');
	}
	else if(isdigit(memblock[readPos])){//constant
		do{
			sname.insert(sname.size(),1,memblock[readPos]);
			readPos++;
		}while(isdigit(memblock[readPos]));
	}
	else{
		if(memblock[readPos]=='>' && memblock[readPos+1]=='='){ sname=">="; readPos++;}
		else if(memblock[readPos]==':' && memblock[readPos+1]=='-') { sname=":-"; readPos++;}
		else if(memblock[readPos]=='<' && memblock[readPos+1]=='>') { sname="<>"; readPos++;}
		else if(memblock[readPos]=='<' && memblock[readPos+1]=='=') { sname="<="; readPos++;}
		else if(memblock[readPos]=='-' && memblock[readPos+1]=='>') { sname="->"; readPos++;}
		else if(memblock[readPos]=='.' && memblock[readPos+1]=='.') { sname=".."; readPos++;}
		else if(memblock[readPos]=='=' && memblock[readPos+1]=='=') { sname="=="; readPos++;}
		else if(memblock[readPos]=='+' && memblock[readPos+1]=='-') { sname="+-"; readPos++;}
		else	sname.insert(sname.size(),1,memblock[readPos]);
		readPos++;
	}
	//Set current symbol id
	if(symbolTable.find(sname)!=symbolTable.end()) symbolId=symbolTable[sname];
	else{
		if(isupper(sname[0])) symbolId=26; //Variable , terminal
		else if(islower(sname[0])) symbolId=19;  //indentifer,terminal
		else if(isdigit(sname[0])) symbolId=14; //Constant
		else symbolId=0; //error happened, due to unknown symbol in the program or query
	}
	return sname;
}

int CParse::SyntaxAnalysis(string fileName)
{
	//std::vector<Symbols*>::iterator itoken;
	string tokenName;
	std::stack<int> stk;
	int j,k;
	int istate=0;
	bool iresult=false;
	if(!ReadFile(fileName)){
		cout<<"Unable to open the input file"<<endl;
		cout<<"Program termintated"<<endl;
		return -1; //File do not found
	}
	stk.push(0);
	tokenName=GetNextToken();
	do{
		if(shift[istate][symbolId]!=-1){
			//std::cout<<"shift "<<istate<<" "<<(*itoken)->name<<" "<<shift[istate][(*itoken)->type]<<std::endl;
			ShiftAction(istate,tokenName);
			stk.push(symbolId);
			istate=shift[istate][symbolId];
			stk.push(istate);
			tokenName=GetNextToken();
		}
		else if(reduce[istate][symbolId]!=-1)
		{
			//std::cout<<"reduce "<<istate<<" "<<(*itoken)->name<<" "<<reduce[istate][(*itoken)->type]<<std::endl;
			if(reduce[istate][symbolId]==0){
				iresult=true;
				break;
			}
			if(!ReduceAction(reduce[istate][symbolId])) return -1;
			for(j=0;j<2*igr[reduce[istate][symbolId]][1];j++) stk.pop();
			j=stk.top();
			k=igr[reduce[istate][symbolId]][0];
			istate=shift[j][k];
			stk.push(k);
			stk.push(istate);
		}
		else {
			break;
		}
	}while(iresult==false);
	//------------------------------------------------------------
	if(iresult==true){
		std::cout<<"Syntax Parse Succeed"<<std::endl;
		//prg->sym=new std::vector<Symbols>(symbol.size());
		//std::copy(symbol.begin(),symbol.end(),prg->sym->begin());
		//ShowSymbolTable();
		//prg->ShowProgram();
	}
	else{
		//Contains some parse error
		ErrorReport();
		std::cout<<"Parsing error" ;
		std::cout<<std::endl;
	}
	//delete [] memblock;
	return iresult;
}


bool CParse::ShiftAction(int istate, string tname)
{
	if(symbolId==14 || symbolId==19 || symbolId==26){
		lstSymbol.push_front(tname);	//For Symbol
	}
	if(tname==":"){//: 
		lstIDL.push_back(":");
	}
	if(tname=="random"){
		TermTree *t1=lstTerm.front();
		rndRule=new Rule(t1->GetName(),rnd_);
		lstTerm.pop_front();
	}
	if(tname=="pr"){
		TermTree *t1=lstTerm.front();
		prRule=new Rule(t1->GetName(),pr);
		lstTerm.pop_front();
	}
	return true;
}

bool CParse::ReduceAction(int rid)
{
	
	Rule* rule;
	Literal *a1;
	TermTree *t1, *t2;
	TermTree *tm1;
	string s1,s2;
	list<string>::iterator itr_sym;

	//std::list<int>::iterator itr_i;
	//std::list<ATNode>::iterator itr_atnode;
	std::list<TermTree*>::iterator itr_tm1, itr_tm2;
	std::list<Literal*>::iterator itr_atm, itr_a1,itr_a2;
	std::list<Rule*>::iterator itr_rule;
	std::list<Literal*>::iterator itr_lit;
	//std::list<Constraint*>::iterator itr_cst;
	//std::cout<<"Rule Ids "<<rid<<std::endl;

	if(rid==17 || rid==18 || rid==19){ // SYM id | const | var
		itr_sym=lstSymbol.begin();
		lstSym.push_front(*itr_sym);
		lstSymbol.pop_front();
	}
	else if(rid==8){//DEF TERM = { TL }
		Sort *s=new Sort(lstTerm.front()->GetName(),list_based);
		itr_tm1=lstTL.front().begin();
		while(itr_tm1!=lstTL.front().end())
		{
			s->Add((*itr_tm1)->GetName());
			++itr_tm1;
		}
		prg->AddSort(s);
		lstTerm.pop_front();
		lstTL.clear();
	}
	else if(rid==9){//DEF TERM = {id .. id}
		Sort *s=new Sort(lstTerm.front()->GetName(), range_based);
		itr_sym=lstSymbol.begin();
		s1=*itr_sym;
		s2=*(++itr_sym);

		int l,h;
		stringstream ss1(s1);
		ss1>>h; 
		stringstream ss2(s2);
		ss2>>l;
		s->SetLowHigh(l,h);
		prg->AddSort(s);
		lstSymbol.clear();
		lstTerm.pop_front();
	}
	else if(rid==10 || rid==11){//
		itr_sym=lstIDL.begin();
		while((*itr_sym)!=":" && itr_sym!=lstIDL.end()){
			Attribute *a=new Attribute(*itr_sym,lstSymbol.front());
			prg->AddAttribute(a);
			++itr_sym;
		}
		lstIDL.clear();
		lstSymbol.clear();
	}
	else if(rid==12){
		//Variables
		Variable *v; 
		itr_sym=lstIDL.begin();
		while(itr_sym!=lstIDL.end()){
			v=new Variable(*itr_sym,lstSymbol.front());
			prg->AddVariable(v);
			++itr_sym;
		}
		lstIDL.clear();
		lstSymbol.clear();
	}
	else if(rid>=13 && rid <= 16){
		lstIDL.push_back(lstSymbol.front());
		lstSymbol.pop_front();
	}
	else if(rid==20){//EXP EXP + TTD
		t1=new TermTree("plus"); // 15 for +
		itr_tm1=lstEXP.begin();
		t1->Append(*itr_tm1);
		itr_tm1=lstTTD.begin();
		t1->Append(*itr_tm1);
		lstEXP.pop_front();
		lstTTD.pop_front();
		lstEXP.push_front(t1);
	}
	else if(rid==21){
		t1=new TermTree("minus"); // 17 for -
		itr_tm1=lstEXP.begin();
		t1->Append(*itr_tm1);
		itr_tm1=lstTTD.begin();
		t1->Append(*itr_tm1);
		lstEXP.pop_front();
		lstTTD.pop_front();
		lstEXP.push_front(t1);
	}
	else if(rid==22){ //EXP TTD
		itr_tm1=lstTTD.begin();
		lstEXP.push_front(*itr_tm1);
		lstTTD.pop_front();
	}
	else if(rid==23){ // TTD TTD * FCT
		t1=new TermTree("times"); // 18 for *
		itr_tm1=lstTTD.begin();
		t1->Append(*itr_tm1);
		itr_tm1=lstFCT.begin();
		t1->Append(*itr_tm1);
		lstTTD.pop_front();
		lstFCT.pop_front();

		lstTTD.push_front(t1);
	}
	else if(rid==24){
		t1=new TermTree("div"); // 20 for /
		itr_tm1=lstTTD.begin();
		t1->Append(*itr_tm1);
		itr_tm1=lstFCT.begin();
		t1->Append(*itr_tm1);
		lstTTD.pop_front();
		lstFCT.pop_front();
		lstTTD.push_front(t1);
	}
	else if(rid==25){//TTD FCT
		itr_tm1=lstFCT.begin();
		lstTTD.push_front(*itr_tm1);
		lstFCT.pop_front();
	}
	else if(rid==26){//FCT ( EXP )
		itr_tm1=lstEXP.begin();
		lstFCT.push_front(*itr_tm1);
		lstEXP.pop_front();
	}
	else if(rid==27){//FCT SYM
		itr_sym=lstSym.begin();
		t1=new TermTree(*itr_sym);
		lstFCT.push_front(t1);
		lstSym.pop_front();
	}
	else if(rid==28){ //TERM EXP
		itr_tm1=lstEXP.begin();
		lstTerm.push_front(*itr_tm1);
		lstEXP.pop_front();
		//cout<<"parse "<<prg->GetAtomName(*itr_atm)<<endl;
	}
	else if(rid==29){//TERM id ( TL )
		itr_sym=lstSymbol.begin();
		t1=new TermTree(*itr_sym);
		
		//itr_tm1=lstEXP.begin();
		//cout<<(*itr_atm)->GetName()<<endl;
		//list<TermTree*> lstT;
		//lstT=lstTL.front();
		//list<TermTree*>::iterator itr_tml; 
		itr_tm1=lstTL.front().begin();
		while(itr_tm1!=lstTL.front().end())
		{
			t1->Append(*itr_tm1);
			itr_tm1++;
		}
		//cout<<(*itr_atm)->GetName()<<endl;
		lstTerm.push_front(t1);
		//lstEXP.pop_front();
		//lstT.clear();
		lstTL.pop_front();
		lstSymbol.pop_front();
		//cout<<"parse2 "<<prg->GetAtomName(*itr_atm)<<endl;
	}
	else if(rid==30){ //TL TL , TERM
		itr_tm1=lstTerm.begin();
		//cout<<"pushed to TL "<<(*itr_atm)->GetName()<<endl;
		lstTL.front().push_back(*itr_tm1);   //Here is push_back
		lstTerm.pop_front();
	}
	else if(rid==31){//TL TERM
		list<TermTree*> lstT;
		lstT.push_back(lstTerm.front());
		lstTL.push_front(lstT);
		lstTerm.pop_front();
	}
	else if(rid==32){// ATOM TERM = TERM
		t1=lstTerm.front();
		lstTerm.pop_front();
		t2=lstTerm.front();
		lstTerm.pop_front();
		a1=new Literal(t2->GetName(),t1->GetName());
		lstAtom.push_front(a1);
		//lstEXP.pop_front();
		//lstTerm.pop_front();
	}
	else if(rid==33){//ATOM TERM
		//t1=new TermTree("true");
		a1=new Literal((*lstTerm.begin())->GetName(), "true");
		lstAtom.push_front(a1);
		lstTerm.pop_front();
	}
	else if(rid==34)//LIT ATOM
	{
		//Literal *l=new Literal(lstAtom.front(),true);
		lstAtom.front()->SetSign(true);
		lstAtom.front()->SetType(regl);
		lstLit.push_front(lstAtom.front());
		lstAtom.pop_front();
	}
	else if(rid==35)//LIT - ATOM
	{
		//Literal *l=new Literal(lstAtom.front(),false);
		//l->SetType(regl);
		lstAtom.front()->SetSign(false);
		lstAtom.front()->SetType(regl);
		lstLit.push_front(lstAtom.front());
		lstAtom.pop_front();
	}
	else if(rid==36){//
		//prg->AddObsStatement(lstLit.front());
		a1=lstLit.front();
		a1->SetType(obs);
		//lstLit.pop_front();
		//lstLit.push_front(l);
	}
	else if(rid==37){
		//prg->AddDoStatement(lstAtom.front());
		a1=lstAtom.front();
		a1->SetType(dos);
		lstAtom.pop_front();
		lstLit.push_front(a1);
	}
	else if(rid==38){//APGR LIT
		rule=new Rule(reg);
		rule->AddHead(lstLit.front());
		prg->AddRule(rule);
		lstLit.pop_front();
	}
	else if(rid==39){//APGR LIT :- BODY
		rule=new Rule(reg);
		rule->AddHead(lstLit.front());
		itr_lit=lstBody.begin();
		while(itr_lit!=lstBody.end()){
			rule->AddBody(*itr_lit);  		
			itr_lit++;
		}
		prg->AddRule(rule);
		lstLit.pop_front();
		lstBody.clear();
	}
	else if(rid==40)//APGR [TERM] HEAD +- BODY
	{
		rule =new Rule(lstTerm.front()->GetName(),cr);
		rule->AddHead(lstLit.front());
		
		itr_lit=lstBody.begin();
		while(itr_lit!=lstBody.end()){
			rule->AddBody(*itr_lit);  		// positive
			itr_lit++;
		}
		prg->AddRule(rule);
		lstLit.pop_front();
		lstTerm.clear();
		lstBody.clear();
	}
	else if(rid==41){//APGR [ TERM ] LIT +-
		rule =new Rule(lstTerm.front()->GetName(),cr);
		rule->AddHead(lstLit.front());
		prg->AddRule(rule);
		lstLit.pop_front();
		lstTerm.clear();
	}
	else if(rid==42){
		rule=new Rule(reg);
		itr_lit=lstBody.begin();
		while(itr_lit!=lstBody.end()){
			rule->AddBody(*itr_lit);  		
			itr_lit++;
		}
		prg->AddRule(rule);
		lstLit.pop_front();
		lstBody.clear();
	}//Nothing to be done for rule 42, 43
	else if(rid==46){//BLT LIT
		//if(lstLit.front()->GetSign()==false) lstNeg.push_back(lstLit.front());
		//else lstPos.push_back(lstLit.front());
		lstLit.front()->SetNaf(true);
		lstBody.push_back(lstLit.front());
		lstLit.pop_front();
	}
	else if(rid==45){//BLT not LIT
		//cout<<lstLit.front()->GetName()<<" ";
		lstLit.front()->SetNaf(false);
		//if(lstLit.front()->GetSign()==false) lstNeg.push_back(lstLit.front());
		//else lstPos.push_back(lstLit.front());
		lstBody.push_back(lstLit.front());
		lstLit.pop_front();
	}
	else if(rid==47){//BLT CMP
		lstLit.front()->SetNaf(true);
		lstBody.push_back(lstLit.front());
		lstLit.pop_front();
	}
	else if(rid>=48 && rid<=53){// ==
		if(rid==48) t1=new TermTree("eq");
		else if(rid==49) t1=new TermTree("neq");
		else if(rid==50) t1=new TermTree("ge");
		else if(rid==51) t1=new TermTree("le");
		else if(rid==52) t1=new TermTree("lt");
		else if(rid==53) t1=new TermTree("gt");
		itr_tm1=lstEXP.begin();
		itr_tm1++;
		t1->Append(*itr_tm1);
		itr_tm1--;
		t1->Append(*itr_tm1);
		a1=new Literal(t1->GetName(),"true");
		//Literal *l=new Literal(a1,true);
		a1->SetType(predefined); //This is a constraint
		lstLit.push_front(a1);
		lstEXP.clear();
	}
	else if(rid==54){ //RSRL RHD
		prg->AddRule(rndRule);
	}
	else if(rid==55){ //RSRL RHD :- BODY
		itr_lit=lstBody.begin();
		while(itr_lit!=lstBody.end()){
			rndRule->AddBody(*itr_lit);  		
			itr_lit++;
		}
		prg->AddRule(rndRule);
		lstBody.clear();
	}
	else if(rid==56){//RHD [ TERM ] random (TERM:{v:Atom})
		itr_sym=lstSymbol.begin();
		t1=new TermTree(*itr_sym);
		tm1=lstTerm.front();
		a1=new Literal(tm1->GetName(),t1->GetName());
		//Literal *l=new Literal(a1, true);
		rndRule->AddVar(*itr_sym);
		rndRule->AddHead(a1);
		rndRule->AddRange(lstAtom.front());
		lstSymbol.clear();
		lstTerm.clear();
		lstAtom.clear();
	}
	else if(rid==57){//RHD [TERM] random (TERM)
		tm1=lstTerm.front();
		//t1=new TermTree("X_"); //special variable for random selection rule
		a1=new Literal(tm1->GetName(),"X_");
		//Literal *l=new Literal(a1, true);
		rndRule->AddVar("X_");
		rndRule->AddHead(a1);
		lstTerm.clear();
	}
	else if(rid==58||rid==59){// pr rules
		a1=lstAtom.front();
		//Literal *l=new Literal(a1,true);
		prRule->AddHead(a1);

		itr_lit=lstBody.begin();
		while(itr_lit!=lstBody.end()){
			prRule->AddBody(*itr_lit);  		
			itr_lit++;
		}
		prRule->SetPrProbability(lstEXP.front()->GetName());
		prg->AddRule(prRule);
		lstEXP.clear();
		lstAtom.clear();
		lstBody.clear();
	}
	else if(rid==61){
		itr_lit=lstBody.begin();
		while(itr_lit!=lstBody.end()){
			qry->AddCondition(*itr_lit);	// positive
			itr_lit++;
		}
		lstBody.clear();
	}
	else if(rid==62){
		qry->SetType(1);
	}
	else if(rid==63){
		qry->formula.clear();
		qry->SetType(3);
	}
	else if(rid==64){ //QHD < TL >
		itr_tm1=lstTL.front().begin();
		while(itr_tm1!=lstTL.front().end()){
			//a1=new Atom(*itr_tm1,NULL);
			qry->terms.push_back((*itr_tm1)->GetName());
			//qry->CollectAtoms(a1);
			++itr_tm1;
		}
		qry->SetType(2); //TL
		lstTL.clear();
	}
	else if(rid==65||rid==66){//
		qry->AddFormula(lstFML.front());
		lstFML.pop_front();
	}
	else if(rid==67){//FML ( FML and FML )
		list<Formula*>::iterator itr_f1;
		Formula *f1, *f2;
		itr_f1=lstFML.begin();
		f1=(*itr_f1);
		++itr_f1;
		f2=(*itr_f1);
		Formula *f=new Formula("and", f1,f2);
		lstFML.pop_front();
		lstFML.pop_front();
		lstFML.push_front(f);
	}
	else if(rid==68){//FML ( FML or FML )
		list<Formula*>::iterator itr_f1;
		Formula *f1, *f2;
		itr_f1=lstFML.begin();
		f1=(*itr_f1);
		++itr_f1;
		f2=(*itr_f1);
		Formula *f=new Formula("or", f1,f2);
		lstFML.pop_front();
		lstFML.pop_front();
		lstFML.push_front(f);
	}
	else if(rid==69){ //FML ! FMC
		Formula *f=new Formula("!",lstFML.front(),NULL); //Negtive
		lstFML.pop_front();
		lstFML.push_front(f);
	}
	else if(rid==70){//FML ATOM
		qry->CollectAtoms(lstAtom.front());
		Formula *f=new Formula(lstAtom.front()); //Positive
		lstFML.push_front(f);
		lstAtom.pop_front();
	}
	return true;
}


